// BOOTSECT.ASM 2.0 generated by Dingo Source Manager 3.6
// Licence: GPL

[org 0]
[dorg 0]
[bits 16]
jmp near MAIN

// Shared Symbolic Constants -->

BPB_FLOPPYSIZE = 13h
BPB_SECS       = 18h
BPB_SFS        = 1Ah
BPB_SETUPSECS  = 40h
BPB_KERNELSECS = 44h
BPB_BOOTDISK   = 48h

// Setup Memory Model
SIZE_BOOTSECT = 512

PA_BOOT         = 7C00h
PA_BOOTSECTCOPY = 600h

PA_SETUP_CODE   = 80000h
PA_SETUP_DATA   = 88000h
PA_SETUP_STACK  = 88000h

SIZE_SETUP_STACK = 8000h - 16

// Kernel Memory Model (physical memory - PA)
PA_IDT         =   800h // size 2 KiB (800h)
PA_PD0         =  1000h // size 4 KiB (1000h)
PA_KERNEL_DATA =  2000h // size 0E000h
PA_GDT         = 10000h // size 32 KiB (8000h)
PA_PT_PROCS    = 18000h // size 4 KiB (1000h)
PA_PT_THREADS  = 19000h // size 4 KiB (1000h)
PA_PT_SD       = 1A000h // size 4 KiB (1000h)
PA_PT_VAR      = 1E000h // size 4 KiB (1000h)
PA_PT_SYS      = 1F000h // size 4 KiB (1000h)
PA_KERNEL_CODE = 20000h // size 256 KiB (40000h)
PA_TMR         = 60000h // size 16 KiB (4000h)
PA_DMA_BUFFERS = 70000h // size 20000h

SIZE_KERNEL_DATA = PA_GDT - PA_KERNEL_DATA
SIZE_GDT         = PA_PT_PROCS - PA_GDT
SIZE_TMR         = 4000h

// Selectors (must match KERNEL_GDT)
SELECTOR_SETUP_CODE  =  8
SELECTOR_KERNEL_CODE = 10h
SELECTOR_KERNEL_DATA = 18h
SELECTOR_USER_CODE   = 20h
SELECTOR_USER_DATA   = 28h
SELECTOR_ALL_CODE    = 30h
SELECTOR_ALL_DATA    = 38h
SELECTOR_VIDEO       = 40h
SELECTOR_TEXTVIDEO   = 48h
SELECTOR_TSS         = 50h
SELECTOR_LDT         = 58h

// Paging
VA_GLOBAL      = 0xC0000000
VA_ACCESS      = 0xD0000000
VA_RAMDISK     = 0xD0000000
VA_GRAPHICS    = 0xE0000000
VA_SYSTEM      = 0xF0000000
VA_PROCS       = 0xF8000000
VA_THREADS     = 0xF9000000
VA_VAR         = 0xFA000000
VA_SD          = 0xFB000000
VA_TIBS        = 0xFC000000
VA_USB         = 0xFD000000
VA_USB_MMIO    = 0xFD100000
VA_KERNEL_HEAP = 0xFE000000

PG_MASK_P   = 1
PG_MASK_W   = 2
PG_MASK_U   = 4
PG_MASK_PWT = 8
PG_MASK_PCD = 16
PG_MASK_A   = 32
PG_MASK_D   = 64
PG_MASK_PS  = 128
PG_MASK_G   = 256

// Initialization constants
KERNEL_GDT_OFS  = 0
KERNEL_GDT_SIZE = 16 * 8
KERNEL_IDT_OFS  = KERNEL_GDT_OFS + KERNEL_GDT_SIZE
KERNEL_IDT_SIZE = 40h * 8

IRQ0INT = 30h
IRQ8INT = 38h

START_SYSTEM_INT = 27h

M_INFO_MAXCOUNT  = 32
M_INFO_ENTRYSIZE = 24

MAX_PROCS   = 512
MAX_THREADS = 1024  // max 1024

// <-- Shared Symbolic Constants


// Shared Structures -->

struct VbeInfoBlock {
   char VbeSignature[4] // == "VESA"
   uns2 VbeVersion      // == 0x0300 for VBE 3.0
   uns4 OemStringPtr    // isa vbeFarPtr
   uns1 Capabilities[4]
   uns4 VideoModePtr    // real mode far ptr to array of words terminated -1
   uns2 TotalMemory     // as # of 64KB blocks
   
   uns2 OemSoftwareRev    // VBE implementation Software revision
   uns4 OemVendorNamePtr  // Pointer to Vendor Name String
   uns4 OemProductNamePtr // Pointer to Product Name String
   uns4 OemProductRevPtr  // Pointer to Product Revision String
   uns1 Reserved[222]     // Reserved for VBE implementation
   uns1 OemData[256]      // Data Area for OEM Strings     
}

struct ModeInfoBlock {
  uns2 attributes
  uns1 winA, winB
  uns2 granularity
  uns2 winsize
  uns2 segmentA, segmentB
  uns4 realFctPtr  // Pointer to window function
  uns2 pitch       // Bytes per scan line
  
  // VBE 1.2
  uns2 xres, yres
  uns1 xchar, ychar, planes, bpp, banks
  uns1 memory_model, bank_size, image_pages
  uns1 reserved0
 
  uns1 red_mask, red_position
  uns1 green_mask, green_position
  uns1 blue_mask, blue_position
  uns1 rsv_mask, rsv_position
  uns1 directcolor_attributes
  
  // VBE 2.0
  uns4 physbase  // LFB (Linear Framebuffer) address
  uns4 OffScreenMemOffset
  uns2 OffScreenMemSize
  
  uns1 reserved[206]
}

// <-- Shared Structures

// BIOS Parameter Block (BPB)

// Offset 3

BPB_osid:        db "TR32 1.2" // OS id (OEM id)

BPB_SectorSize:  dw 512   // Sector size [B]
BPB_ClusterSize: db 2     // Cluster size [sect]
BPB_Reserved:    dw 512   // Number of reserved sectors
BPB_FATs:        db 2     // Number of FATs
BPB_maxroot:     dw 0E0h  // Max number of files in the root directory
BPB_secs:        dw 2880  // Disk size in sectors
BPB_formatid:    db 0F0h  // Media descriptor - FAT12
BPB_FATsize:     dw 9     // Size of FAT in sectors
BPB_Sectors:     dw 18    // Sectors per track
BPB_Surfaces:    dw 2     // Number of surfaces
BPB_Before:      dd 0     // Partition offset (0)

// Offset 20h

setupsecs:  dd 8    // Size of setup in sectors
kernelsecs: dd 32   // Size of kernel in sectors
bootdisk:   dd 'A'  // letter of this disk

writecsz:
l_writecsz_1:
	mov al, cs:[si]
	inc si
	or al,al
	jz l_writecsz_9
		xor bh,bh
		mov ah,0Eh
		int 10h
		jmp l_writecsz_1
l_writecsz_9:
ret

uns2 cyl,sf,sect

load_secs_9:
ret

load_secs:
load_secs_1:
jcxz load_secs_9

// Check sect and sf, keep cx  (cx = number of remaining sectors to read)

mov ax, sect
cmp ax, cs:[offset BPB_Sectors]
jna l_load_secs_1
	mov sect, 1
	inc sf
l_load_secs_1:
mov ax, sf
cmp ax, cs:[offset BPB_Surfaces]
jb l_load_secs_2
	mov sf, 0
	inc cyl
l_load_secs_2:

// Read whole track if possible

mov ax, cs:[offset BPB_Sectors]
sub ax, sect
inc ax	// ax = number of remaining sectors on the track, 1..63
cmp ax, cx
jna l_load_secs_3
	mov ax, cx	// Don't read more than cx secs
l_load_secs_3:
push ax
 push cx

  // Prepare registers, keep al

  mov cl, byte ptr sect
  mov dh, byte ptr sf
  mov ch, byte ptr cyl
  mov dl, 0  // A:
  mov bx, di

  // Call BIOS service to read it

  mov ah, 02h
  int 13h
  jc load_secs_error

  // Next sector

 pop cx
pop ax			// number of sectors read (1..63)
sub cx, ax		// sub from remaining sectors
add sect, ax	// add to sector number, overflow is solved above
shl ax, 5		// 5 = log2(32), sector = 32 paragraphs (512/16)
mov dx, es
add ax, dx
mov es, ax		// es += 32 * number of sectors read
jmp load_secs_1



// Write error message

load_secs_error:
mov si, offset msg_disk_read_error
call writecsz
load_secs_die: jmp load_secs_die

MAIN:

// Set stack

mov sp, SIZE_SETUP_STACK
mov dx, PA_SETUP_STACK / 16
mov ss, dx

// Copy self to PA_BOOTSECTCOPY/16:0 and jump there

mov dx, PA_BOOT / 16
mov ds, dx
xor si, si
mov dx, PA_BOOTSECTCOPY / 16
mov es, dx
xor di, di
mov cx, SIZE_BOOTSECT / 2
cld
rep movsw

jmp far (PA_BOOTSECTCOPY / 16):l_continue



// Executed at PA_BOOTSECTCOPY/16:l_continue

l_continue:

// Write 'Loading...'

mov si, offset msg_loading
call writecsz

// Setup data segment

mov dx, PA_SETUP_DATA / 16
mov ds, dx

mov cyl,  0
mov sf,   0
mov sect, 2

// Load setup

mov dx, PA_SETUP_CODE / 16
mov es, dx
xor di, di
mov cx, cs:[offset setupsecs]
call load_secs

// Load kernel

mov dx, PA_KERNEL_CODE / 16
mov es, dx
xor di, di
mov cx, cs:[offset kernelsecs]
call load_secs

// Transport boot disk to setup

mov dx, cs:[offset bootdisk]

// Start setup

jmp far (PA_SETUP_CODE / 16):0

msg_loading: db "Loading...\0"

msg_disk_read_error: db "\r\nDisk read error\r\n\0"

LASTOFFSET:
