// BOOTSECT.ASM 2.0 generated by Dingo Source Manager 3.6
// Licence: GPL

[org 0]
[dorg 0]
[bits 16]
jmp near MAIN

// BIOS Parameter Block (BPB)

// Offset 3

BPB_osid:        db "TR32 1.2" // OS id (OEM id)

BPB_SectorSize:  dw 512   // Sector size [B]
BPB_ClusterSize: db 8     // Cluster size [sect]
BPB_Reserved:    dw 512   // Number of reserved sectors
                 db 0,0,0 // 0 for compatibility
BPB_FDSize:      dw 0     // FD: Total sectors
BPB_FormatId:    db 0     // Format identification
                 dw 0     // 0 for compatibility
BPB_Sectors:     dw 0     // Sectors per track
BPB_Surfaces:    dw 0     // Number of surfaces
BPB_Before:      dd 0     // Partition offset (0)

// Offset 20h

setupsecs:  dd 0  // Size of setup in sectors 512?
kernelsecs: dd 0  // Size of kernel in sectors 512?
bootdisk:   dd 0  // Logical disk number
syssect:    dq 0  // Offset of system in sectors 512?

// Shared Symbolic Constants -->

BPB_FLOPPYSIZE = 13h
BPB_SECS       = 18h
BPB_SFS        = 1Ah
BPB_SETUPSECS  = 40h
BPB_KERNELSECS = 44h
BPB_BOOTDISK   = 48h

// Setup Memory Model
SIZE_BOOTSECT = 512

PA_BOOT         = 7C00h
PA_BOOTSECTCOPY = 600h

PA_SETUP_CODE   = 80000h
PA_SETUP_DATA   = 88000h
PA_SETUP_STACK  = 88000h

SIZE_SETUP_STACK = 8000h - 16

// Kernel Memory Model (physical memory - PA)
PA_IDT         =   800h // size 2 KiB (800h)
PA_PD0         =  1000h // size 4 KiB (1000h)
PA_KERNEL_DATA =  2000h // size 0E000h
PA_GDT         = 10000h // size 32 KiB (8000h)
PA_PT_PROCS    = 18000h // size 4 KiB (1000h)
PA_PT_THREADS  = 19000h // size 4 KiB (1000h)
PA_PT_SD       = 1A000h // size 4 KiB (1000h)
PA_PT_VAR      = 1E000h // size 4 KiB (1000h)
PA_PT_SYS      = 1F000h // size 4 KiB (1000h)
PA_KERNEL_CODE = 20000h // size 256 KiB (40000h)
PA_TMR         = 60000h // size 16 KiB (4000h)
PA_DMA_BUFFERS = 70000h // size 20000h

SIZE_KERNEL_DATA = PA_GDT - PA_KERNEL_DATA
SIZE_GDT         = PA_PT_PROCS - PA_GDT
SIZE_TMR         = 4000h

// Selectors (must match KERNEL_GDT)
SELECTOR_SETUP_CODE  =  8
SELECTOR_KERNEL_CODE = 10h
SELECTOR_KERNEL_DATA = 18h
SELECTOR_USER_CODE   = 20h
SELECTOR_USER_DATA   = 28h
SELECTOR_ALL_CODE    = 30h
SELECTOR_ALL_DATA    = 38h
SELECTOR_VIDEO       = 40h
SELECTOR_TEXTVIDEO   = 48h
SELECTOR_TSS         = 50h
SELECTOR_LDT         = 58h

// Paging
VA_GLOBAL      = 0xC0000000
VA_ACCESS      = 0xD0000000
VA_RAMDISK     = 0xD0000000
VA_GRAPHICS    = 0xE0000000
VA_SYSTEM      = 0xF0000000
VA_PROCS       = 0xF8000000
VA_THREADS     = 0xF9000000
VA_VAR         = 0xFA000000
VA_SD          = 0xFB000000
VA_TIBS        = 0xFC000000
VA_USB         = 0xFD000000
VA_USB_MMIO    = 0xFD100000
VA_KERNEL_HEAP = 0xFE000000

PG_MASK_P   = 1
PG_MASK_W   = 2
PG_MASK_U   = 4
PG_MASK_PWT = 8
PG_MASK_PCD = 16
PG_MASK_A   = 32
PG_MASK_D   = 64
PG_MASK_PS  = 128
PG_MASK_G   = 256

// Initialization constants
KERNEL_GDT_OFS  = 0
KERNEL_GDT_SIZE = 16 * 8
KERNEL_IDT_OFS  = KERNEL_GDT_OFS + KERNEL_GDT_SIZE
KERNEL_IDT_SIZE = 40h * 8

IRQ0INT = 30h
IRQ8INT = 38h

START_SYSTEM_INT = 27h

M_INFO_MAXCOUNT  = 32
M_INFO_ENTRYSIZE = 24

MAX_PROCS   = 512
MAX_THREADS = 1024  // max 1024

// <-- Shared Symbolic Constants


// Shared Structures -->

struct VbeInfoBlock {
   char VbeSignature[4] // == "VESA"
   uns2 VbeVersion      // == 0x0300 for VBE 3.0
   uns4 OemStringPtr    // isa vbeFarPtr
   uns1 Capabilities[4]
   uns4 VideoModePtr    // real mode far ptr to array of words terminated -1
   uns2 TotalMemory     // as # of 64KB blocks
   
   uns2 OemSoftwareRev    // VBE implementation Software revision
   uns4 OemVendorNamePtr  // Pointer to Vendor Name String
   uns4 OemProductNamePtr // Pointer to Product Name String
   uns4 OemProductRevPtr  // Pointer to Product Revision String
   uns1 Reserved[222]     // Reserved for VBE implementation
   uns1 OemData[256]      // Data Area for OEM Strings     
}

struct ModeInfoBlock {
  uns2 attributes
  uns1 winA, winB
  uns2 granularity
  uns2 winsize
  uns2 segmentA, segmentB
  uns4 realFctPtr  // Pointer to window function
  uns2 pitch       // Bytes per scan line
  
  // VBE 1.2
  uns2 xres, yres
  uns1 xchar, ychar, planes, bpp, banks
  uns1 memory_model, bank_size, image_pages
  uns1 reserved0
 
  uns1 red_mask, red_position
  uns1 green_mask, green_position
  uns1 blue_mask, blue_position
  uns1 rsv_mask, rsv_position
  uns1 directcolor_attributes
  
  // VBE 2.0
  uns4 physbase  // LFB (Linear Framebuffer) address
  uns4 OffScreenMemOffset
  uns2 OffScreenMemSize
  
  uns1 reserved[206]
}

// <-- Shared Structures

struct DiskAddressPacket{
  uns1 size, rsv_0  // 10h
  uns2 count  // max 7Fh
  uns2 ofs, seg
  uns8 lba
  uns8 rsv_1
}

[dorg 0]

uns1 pbootdisk

[dalign 64]
DiskAddressPacket dap

writecsz:
pusha
l_writecsz_1:
  mov al, cs:[si]
  inc si
  or al, al
  jz l_writecsz_9
    xor bh, bh
    mov ah, 0Eh
    int 10h
    jmp l_writecsz_1
  
l_writecsz_9:
popa
ret

// load setup, load kernel, jmp to setup

msg_loading: db "Loading...\0"
str1: db "BIOS EXT required\0"
str2: db "Disk read error\0"

MAIN:

// Set stack
mov sp, SIZE_SETUP_STACK
mov ax, PA_SETUP_STACK / 16
mov ss, ax

push dx
  
  // Copy self to PA_BOOTSECTCOPY/16:0
  mov ax, PA_BOOT / 16
  mov ds, ax
  xor si, si
  mov ax, PA_BOOTSECTCOPY / 16
  mov es, ax
  xor di, di
  mov cx, 2048 / 2
  cld
  rep movsw
  
  // Set ds, es
  mov ax, PA_SETUP_DATA / 16
  mov ds, ax
  mov es, ax
  
pop dx

mov pbootdisk, dl

// Jump to BootSectCopy
jmp far (PA_BOOTSECTCOPY / 16):l_continue

// Executed at PA_BOOTSECTCOPY/16:l_continue
l_continue:

// Write 'Loading...'
mov si, offset msg_loading
call writecsz

// Check for BIOS ext
mov dl, pbootdisk
mov bx, 55AAh
mov ah, 41h
int 13h
jnc l_main_2
  mov si, offset str1
  call writecsz
  l_main_1: jmp l_main_1
  
l_main_2:

// Read setup
mov cx, [cs:offset setupsecs]

mov dap.seg, PA_SETUP_CODE / 16
mov dap.ofs, 0

mov dap.size, 10h
mov dap.count, 1

mov ax, word ptr [cs:offset syssect + 0]
mov cx, word ptr [cs:offset syssect + 2]
mov word ptr dap.lba[0], ax
mov word ptr dap.lba[2], cx
mov ax, word ptr [cs:offset syssect + 4]
mov cx, word ptr [cs:offset syssect + 6]
mov word ptr dap.lba[4], ax
mov word ptr dap.lba[6], cx

l_main_4:
  push cx
    mov dl, pbootdisk
    mov si, offset dap
    mov ah, 42h
    int 13h
    jnc l_main_46
      
      l_main_44:
      mov si, offset str2
      call writecsz
      l_main_45: jmp l_main_45
      
    l_main_46:
    add word ptr dap.lba[0], 1
    adc word ptr dap.lba[2], 0
    adc word ptr dap.lba[4], 0
    adc word ptr dap.lba[6], 0    

    add dap.seg, 512 / 16
  pop cx
  loop l_main_4

// Read kernel  IN: dap
mov cx, [cs:offset kernelsecs]

mov dap.seg, PA_KERNEL_CODE / 16

l_main_5:
  push cx
    mov dl, pbootdisk
    mov si, offset dap
    mov ah, 42h
    int 13h
    jc l_main_44
    
    add word ptr dap.lba[0], 1
    adc word ptr dap.lba[2], 0
    adc word ptr dap.lba[4], 0
    adc word ptr dap.lba[6], 0

    add dap.seg, 512 / 16
  pop cx
  loop l_main_5

// Transport boot disk to setup
mov dx, [cs:offset bootdisk]

// Start setup
jmp far (PA_SETUP_CODE / 16):0

