// SETUP.ASM 2.0 generated by Dingo Source Manager 3.6
// Licence: GPL

[org 0]
[bits 16]
jmp MAIN

// Shared Symbolic Constants -->

BPB_FLOPPYSIZE = 13h
BPB_SECS       = 18h
BPB_SFS        = 1Ah
BPB_SETUPSECS  = 40h
BPB_KERNELSECS = 44h
BPB_BOOTDISK   = 48h

// Setup Memory Model
SIZE_BOOTSECT = 512

PA_BOOT         = 7C00h
PA_BOOTSECTCOPY = 600h

PA_SETUP_CODE   = 80000h
PA_SETUP_DATA   = 88000h
PA_SETUP_STACK  = 88000h

SIZE_SETUP_STACK = 8000h - 16

// Kernel Memory Model (physical memory - PA)
PA_IDT         =   800h // size 2 KiB (800h)
PA_PD0         =  1000h // size 4 KiB (1000h)
PA_KERNEL_DATA =  2000h // size 0E000h
PA_GDT         = 10000h // size 32 KiB (8000h)
PA_PT_PROCS    = 18000h // size 4 KiB (1000h)
PA_PT_THREADS  = 19000h // size 4 KiB (1000h)
PA_PT_SD       = 1A000h // size 4 KiB (1000h)
PA_PT_VAR      = 1E000h // size 4 KiB (1000h)
PA_PT_SYS      = 1F000h // size 4 KiB (1000h)
PA_KERNEL_CODE = 20000h // size 256 KiB (40000h)
PA_TMR         = 60000h // size 16 KiB (4000h)
PA_DMA_BUFFERS = 70000h // size 20000h

SIZE_KERNEL_DATA = PA_GDT - PA_KERNEL_DATA
SIZE_GDT         = PA_PT_PROCS - PA_GDT
SIZE_TMR         = 4000h

// Selectors (must match KERNEL_GDT)
SELECTOR_SETUP_CODE  =  8
SELECTOR_KERNEL_CODE = 10h
SELECTOR_KERNEL_DATA = 18h
SELECTOR_USER_CODE   = 20h
SELECTOR_USER_DATA   = 28h
SELECTOR_ALL_CODE    = 30h
SELECTOR_ALL_DATA    = 38h
SELECTOR_VIDEO       = 40h
SELECTOR_TEXTVIDEO   = 48h
SELECTOR_TSS         = 50h
SELECTOR_LDT         = 58h

// Paging
VA_GLOBAL      = 0xC0000000
VA_ACCESS      = 0xD0000000
VA_RAMDISK     = 0xD0000000
VA_GRAPHICS    = 0xE0000000
VA_SYSTEM      = 0xF0000000
VA_PROCS       = 0xF8000000
VA_THREADS     = 0xF9000000
VA_VAR         = 0xFA000000
VA_SD          = 0xFB000000
VA_TIBS        = 0xFC000000
VA_USB         = 0xFD000000
VA_USB_MMIO    = 0xFD100000
VA_KERNEL_HEAP = 0xFE000000

PG_MASK_P   = 1
PG_MASK_W   = 2
PG_MASK_U   = 4
PG_MASK_PWT = 8
PG_MASK_PCD = 16
PG_MASK_A   = 32
PG_MASK_D   = 64
PG_MASK_PS  = 128
PG_MASK_G   = 256

// Initialization constants
KERNEL_GDT_OFS  = 0
KERNEL_GDT_SIZE = 16 * 8
KERNEL_IDT_OFS  = KERNEL_GDT_OFS + KERNEL_GDT_SIZE
KERNEL_IDT_SIZE = 40h * 8

IRQ0INT = 30h
IRQ8INT = 38h

START_SYSTEM_INT = 27h

M_INFO_MAXCOUNT  = 32
M_INFO_ENTRYSIZE = 24

MAX_PROCS   = 512
MAX_THREADS = 1024  // max 1024

// <-- Shared Symbolic Constants


// Shared Structures -->

struct VbeInfoBlock {
   char VbeSignature[4] // == "VESA"
   uns2 VbeVersion      // == 0x0300 for VBE 3.0
   uns4 OemStringPtr    // isa vbeFarPtr
   uns1 Capabilities[4]
   uns4 VideoModePtr    // real mode far ptr to array of words terminated -1
   uns2 TotalMemory     // as # of 64KB blocks
   
   uns2 OemSoftwareRev    // VBE implementation Software revision
   uns4 OemVendorNamePtr  // Pointer to Vendor Name String
   uns4 OemProductNamePtr // Pointer to Product Name String
   uns4 OemProductRevPtr  // Pointer to Product Revision String
   uns1 Reserved[222]     // Reserved for VBE implementation
   uns1 OemData[256]      // Data Area for OEM Strings     
}

struct ModeInfoBlock {
  uns2 attributes
  uns1 winA, winB
  uns2 granularity
  uns2 winsize
  uns2 segmentA, segmentB
  uns4 realFctPtr  // Pointer to window function
  uns2 pitch       // Bytes per scan line
  
  // VBE 1.2
  uns2 xres, yres
  uns1 xchar, ychar, planes, bpp, banks
  uns1 memory_model, bank_size, image_pages
  uns1 reserved0
 
  uns1 red_mask, red_position
  uns1 green_mask, green_position
  uns1 blue_mask, blue_position
  uns1 rsv_mask, rsv_position
  uns1 directcolor_attributes
  
  // VBE 2.0
  uns4 physbase  // LFB (Linear Framebuffer) address
  uns4 OffScreenMemOffset
  uns2 OffScreenMemSize
  
  uns1 reserved[206]
}

// <-- Shared Structures

writecz:
l_writecz_1:
	mov al, cs:[si]
	inc si
	or al, al
	jz l_writecz_9
		xor bh, bh
		mov ah, 0Eh
		int 10h
		jmp l_writecz_1
l_writecz_9:
ret

delay:
jmp short l_delay_8
l_delay_8:
ret

// DESTROY: al
empty_8042:
call delay
in al, 0x64		// 8042 status port
test al, 1		// Anything to read?
jz l_empty_8042_no_output
	call delay
	in al, 0x60	// Read it
	jmp	empty_8042
l_empty_8042_no_output:
test al, 2		// Is input buffer full?
jnz	empty_8042
ret

// Setup Constants

idt_48: dw 2047,       PA_IDT & 65535, PA_IDT / 65536	// limit, baselw, basehw
gdt_48: dw SIZE_GDT-1, PA_GDT & 65535, PA_GDT / 65536	// limit, baselw, basehw

msg_starting_pm: db "\r\nStarting protected mode\r\n\0"
msg_a20_error: db "A20 error\r\n\0"
msg_vesa2: db "VESA 2.0 required\r\n\0"
msg_graphics_error: db "No 32bit video mode\r\n\0"
//msg_minit_error: db "Memory initialization error\r\n\0"

// Shared Kernel Variables -->

[dorg 2000h] // PA_KERNEL_DATA

// set by the setup

uns2 cur_pos

uns2 boot_disk  // 0x300 = cd

[dalign 32]
uns4 m_RAMSize
uns4 m_info_count
uns1 m_info[M_INFO_MAXCOUNT * M_INFO_ENTRYSIZE]

[dalign 32]
uns4 m_lastbyte, m_bitmap_base, m_bitmap_size, m_first_alloc

ModeInfoBlock g_info
uns2 g_mode

// <-- Shared Kernel Variables

[dalign 32]
uns4 mt_done

ModeInfoBlock g_info2

VbeInfoBlock vib

// IN: dx = boot disk BIOS number (0 = A:, 80h = C:)
MAIN:

// ds = es = 0
xor ax, ax
mov ds, ax
mov es, ax

// Save boot disk BIOS number
mov boot_disk, dx

// Write 'Starting protected mode'
mov si, offset msg_starting_pm
call writecz

// Kill floppy motor
mov dx, 0x3F2
xor al, al
out dx, al

// Maximalize keyboard repeat rate
mov ax, 0x305
xor bx, bx
int 16h

// Reset coprocessor
xor ax, ax
out 0F0h, al
call delay
out 0F1h, al
call delay

// Read cursor position and save it to kernel data
mov ah, 3
xor bh, bh
int 10h
mov cur_pos, dx

// Get RAM Size Using BIOS
// dq base, size; dd type, ACPI3ext
// EBDA: 9F000h (1000h)
// if( type == 1 && size >= 1000h && base >= 100000h ) => available memory block

// assume ds, es = 0
xor eax, eax
mov m_RAMSize, eax

mov di, offset m_info
xor ebx, ebx

l_m_getRAMsize_5:
  mov edx, 0x534D4150
  mov eax, 0xE820
  mov ecx, M_INFO_ENTRYSIZE
  int 0x15
  jc l_m_getRAMsize_error
    cmp eax, 0x534D4150
    jnz l_m_getRAMsize_error
      cmp cl, 20
      jnz l_m_getRAMsize_52
        xor eax, eax
        inc ax
        mov [es:di+20], eax
      l_m_getRAMsize_52:
      add di, M_INFO_ENTRYSIZE
      test ebx, ebx
      jz l_m_getRAMsize_6
        cmp di, (offset m_info + (M_INFO_MAXCOUNT * M_INFO_ENTRYSIZE))
        jb l_m_getRAMsize_5

l_m_getRAMsize_6:
xor eax, eax
mov ax, di
sub ax, offset m_info
mov cx, M_INFO_ENTRYSIZE
xor dx, dx
div cx
mov m_info_count, eax
jmp l_m_getRAMsize_8

l_m_getRAMsize_error:
xor eax, eax
mov m_info_count, eax

l_m_getRAMsize_8:

// Detect Graphics - 640x480
push ds
pop es
mov di, offset vib
mov ax, 4F00h
int 10h
cmp al, 4Fh
jz l_detect_graphics_2
  
  l_detect_graphics_0:
  mov si, offset msg_vesa2
  call writecz
  
  l_detect_graphics_1: jmp short l_detect_graphics_1

l_detect_graphics_2:
cmp vib.VbeVersion, 200h
jb l_detect_graphics_0

mov es, word ptr vib.VideoModePtr[2]
mov si, word ptr vib.VideoModePtr[0]

mov g_mode, 0

l_detect_graphics_5:
  mov cx, es:[si]
  add si, 2
  cmp cx, -1
  jz l_detect_graphics_8
    push es
      push ds
      pop es
      mov di, offset g_info2
      mov ax, 4F01h
      push cx
       push si
        int 10h
       pop si
      pop cx
    pop es
    cmp al, 4Fh
    jnz l_detect_graphics_8
    
    // bpp 32, xres, yres
    cmp g_info2.bpp, 32
    jnz l_detect_graphics_5
      cmp g_info2.xres, 640
      jnz l_detect_graphics_5
        cmp g_info2.yres, 480
        jnz l_detect_graphics_5
    
    l_detect_graphics_6:
    mov g_mode, cx
    push es
     push si
      push ds
      pop es
      mov si, offset g_info2
      mov di, offset g_info
      mov cx, sizeof ModeInfoBlock
      cld
      rep movsb
     pop si
    pop es
    jmp l_detect_graphics_5

l_detect_graphics_8:

/*
jmp l0

// IN: ax = number
writen:
mov cx, 4
wn1:
mov si, 16
xor dx, dx
div si
push ax
 push cx
  mov al, dl
  cmp al, 10
  jnb wn2
    add al, '0'
    jmp short wn3
  wn2:
    add al, 55
  wn3:
  xor bh, bh
  mov ah, 0Eh
  int 10h
 pop cx
pop ax
loop wn1
ret


l0:
mov ax, word ptr g_info.physbase
call writen
mov ax, word ptr g_info.physbase[2]
call writen

l1:jmp l1
*/

cmp g_mode, 0
jz l_sg_7

// Set Graphic Mode
mov ax, 4F02h
mov bx, g_mode
or bx, 4000h  // create linear frame buffer
int 10h
cmp al, 4Fh
jz l_sg_8

  l_sg_7:
  mov si, offset msg_graphics_error
  call writecz
  jmp l_setup_die

l_sg_8:

/*
// Set Bank
mov ax, 4F05h
mov bl, 0 // Window 0=A, 1=B
mov bh, 0
xor dx, dx
int 10h

// Set Begin
mov ax, 4F07h
xor bx, bx
xor cx, cx
xor dx, dx
int 10h
*/

l_enable_a20_1:

// Enable A20
call empty_8042
mov al, 0D1h // command write
out 64h, al  // 8042 status port
call empty_8042
mov al, 0DFh // A20 on
out 60h, al
call empty_8042

// Assert it worked
xor ax, ax
mov ds, ax
push es
  mov dx, 0xFFFF
  mov es, dx
  mov byte[500h], 1
  mov byte[es:510h], 2
  jmp short l_enable_a20_2
  l_enable_a20_2:
  mov al, [500h]
  mov dl, [es:510h]
pop es
cmp al, 1
jnz l_enable_a20_error
  cmp dl, 2
  jz l_enable_a20_9

l_enable_a20_error:
mov si, offset msg_a20_error
call writecz
jmp l_enable_a20_1

l_enable_a20_9:

// Init IRQs -->

cli

mov al, 11h  // initialization sequence
out 20h, al  // send it to 8259A-1
call delay

out 0A0h, al  // and to 8259A-2
call delay

mov al, IRQ0INT // IRQ 0-7
out 21h, al
call delay

mov al, IRQ8INT // IRQ 8-15
out 0A1h, al
call delay

mov al, 4     // 8259-1 is master
out 21h, al
call delay

mov al, 2     // 8259-2 is slave
out 0A1h, al
call delay

mov al, 01    // 8086 mode for both
out 21h, al
call delay

out 0A1h, al
call delay

mov al, 0FFh  // mask off all interrupts for now
out 0A1h, al
call delay

mov al, 0FBh  // mask all irqs but irq2 which is cascaded
out 21h, al

// <-- Init IRQs

// Init GDT

// Copy [PA_KERNEL_CODE/16:KERNEL_GDT_OFS] -> [PA_GDT] (KERNEL_GDT_SIZE)
push ds
 mov bx, PA_KERNEL_CODE / 16
 mov ds, bx
 mov si, KERNEL_GDT_OFS
 mov cx, KERNEL_GDT_SIZE / 2
 mov bx, PA_GDT / 16
 mov es, bx
 xor di, di
 cld
 rep movsw
pop ds

// Fill the rest of GDT with 0s
xor ax, ax
mov cx, (SIZE_GDT - KERNEL_GDT_SIZE) / 2
rep stosw

// Set GDT
lgdt [cs:offset gdt_48]

// Init IDT

// Copy [PA_KERNEL_CODE/16:KERNEL_IDT_OFS] -> [PA_IDT] (KERNEL_IDT_SIZE)
push ds
 mov bx, PA_KERNEL_CODE / 16
 mov ds, bx
 mov si, KERNEL_IDT_OFS
 mov cx, KERNEL_IDT_SIZE / 2
 mov bx, PA_IDT / 16
 mov es, bx
 xor di, di
 cld
 rep movsw
pop ds

// Fill the rest of IDT with 0s
xor ax, ax
mov cx, ((256 * 8) - KERNEL_IDT_SIZE) / 2
rep stosw

// Set IDT
lidt [cs:offset idt_48]

// Enter protected mode

mov eax, 1
mov cr0, eax

// flush instruction queue
jmp short l_pm_1
l_pm_1:

// load cs cache
jmp far SELECTOR_SETUP_CODE:l_protected_mode



[bits 32]

l_protected_mode:

// Set segment registers, stack
mov dx, SELECTOR_KERNEL_DATA
mov ds, dx
mov es, dx
mov fs, dx
mov gs, dx

mov ss, dx
mov esp, PA_SETUP_STACK + SIZE_SETUP_STACK

// Init flags
xor eax, eax
push eax
popfd

// Set initial TR - done later, in p_init

// Get RAM Size Using Probing -->

// IN: ds = KERNEL_DATA

mov eax, m_info_count
test eax, eax
jnz near l_m_init_8  // done, no probing

// Probe memory size

mov ax, SELECTOR_ALL_DATA
mov es, ax  // es = all

mov edx, 1024 * 1024  // edx = 1 MiB
mov ebx, edx

l_m_init_11:
mov al, 5Ah
mov [es:ebx], al
xor al, al
mov al, [es:ebx]
cmp al, 5Ah
jnz l_m_init_15
  add ebx, edx
  test ebx, ebx
  jnz l_m_init_11

    mov eax, 4 * 1024  // 4 GiB RAM overflow
    mov m_RAMSize, eax
    jmp l_m_init_18

l_m_init_15:
  shr ebx, 20
  mov m_RAMSize, ebx

l_m_init_18:

// Simulate m_info

mov m_info_count, 2
push ds
pop es  // es = ds
mov edi, offset m_info
push edi
  xor eax, eax
  mov ecx, 2 * M_INFO_ENTRYSIZE / 4
  cld
  rep stosd
pop edi

xor edx, edx
inc edx  // edx = 1

add edi, 8
mov eax, 0xA0000
stosd
add edi, 4
xchg eax, edx
stosd
stosd
xchg eax, edx

mov eax, 0x100000
stosd
add edi, 4
mov ecx, m_RAMSize
shl ecx, 20
sub ecx, eax
xchg eax, ecx
stosd
add edi, 4
xchg eax, edx
stosd
stosd
xchg eax, edx

l_m_init_8:

// <-- Get RAM Size Using Probing

// Prepare thread selectors

RIGHTS_TSS =  1  | 80h | 8
EXT_SIZE   = 40h

mov edi, PA_GDT + KERNEL_GDT_SIZE
mov ecx, MAX_THREADS
mov ebx, VA_THREADS

l_prep_t_15:
  mov eax, ebx
  shl eax, 16
  mov ax, 4095  // assert sizeof ThreadRec = 4096
  mov [edi], eax
  
  mov eax, ebx
  mov edx, ebx
  shr eax, 16
  and eax, 0xFF
  and edx, 0xFF000000
  or eax, edx
  or eax, RIGHTS_TSS << 8
  or eax, EXT_SIZE << 16
  mov [edi + 4], eax
  
  add edi, 8
  add ebx, 4096  // assert sizeof ThreadRec = 4096
  loop l_prep_t_15

// Prepare TIB selectors

RIGHTS_TIB = 10h | 80h | 2 | 60h

mov edi, PA_GDT + KERNEL_GDT_SIZE + (MAX_THREADS * 8)
mov ecx, MAX_THREADS
mov ebx, VA_TIBS

l_prep_t_25:
  mov eax, ebx
  shl eax, 16
  mov ax, 4095  // assert sizeof TIBRec = 4096
  mov [edi], eax
  
  mov eax, ebx
  mov edx, ebx
  shr eax, 16
  and eax, 0xFF
  and edx, 0xFF000000
  or eax, edx
  or eax, RIGHTS_TIB << 8
  or eax, EXT_SIZE << 16
  mov [edi + 4], eax
  
  add edi, 8
  add ebx, 4096  // assert sizeof TIBRec = 4096
  loop l_prep_t_25

// Prepare Memory Allocation -->

// es = ds = ALL

mov ax, SELECTOR_ALL_DATA
mov ds, ax
mov es, ax


// Calc m_lastbyte

mov ebx, offset m_info
mov ecx, m_info_count
xor esi, esi
xor edi, edi
inc esi

l_pg_11:
  cmp byte[ebx+16], 1  // memtype
  jnz l_pg_18
    mov eax, [ebx]
    mov edx, [ebx+4]
    add eax, [ebx+8]
    adc edx, [ebx+12]
    cmp edx, edi
    jb l_pg_18
    ja l_pg_16
      cmp eax, esi
      jna l_pg_18
    l_pg_16:
    mov esi, eax
    mov edi, edx
    l_pg_18:
    add ebx, M_INFO_ENTRYSIZE
    loop l_pg_11

test edi, edi
jz l_pg_19
  xor esi, esi
l_pg_19:
dec esi
mov eax, 0xEFFFFFFF
cmp esi, eax
jna l_pg_192
  mov esi, eax
l_pg_192:
mov m_lastbyte, esi


// Calc m_bitmap_base, m_bitmap_size (round down)

mov ebx, offset m_info
mov ecx, m_info_count

l_pg_21:
  cmp byte[ebx+16], 1  // memtype
  jnz l_pg_28
    mov eax, [ebx]
    cmp eax, 0x100000
    jb l_pg_28
      mov m_bitmap_base, eax
      mov eax, m_lastbyte
      inc eax
      test eax, eax
      jnz l_pg_22
        dec eax
      l_pg_22:
      shr eax, 15
      mov edx, [ebx+12]
      test edx, edx
      jnz l_pg_26
        mov edx, [ebx+8]
        cmp eax, edx
        jna l_pg_26
          mov eax, edx

      l_pg_26:
      mov m_bitmap_size, eax
      jmp short l_pg_29

  l_pg_28:
  add ebx, M_INFO_ENTRYSIZE
  loop l_pg_21

// Memory initialisation error
//mov si, offset msg_minit_error
//call writecz
jmp l_setup_die

l_pg_29:


// Prepare Bitmap

mov eax, m_bitmap_base
add eax, m_bitmap_size
dec eax
or ax, 4095
inc eax
mov edi, eax
mov m_first_alloc, eax
mov mt_done, eax
xor esi, esi
shr edi, 12
mov ah, 1
call m_set_bitmap

mov ebx, offset m_info
mov ecx, m_info_count

l_pg_31:
  cmp byte[ebx+16], 1  // memtype
  jnz l_pg_38
    mov esi, [ebx]
    mov edi, [ebx+4]
    mov eax, [ebx+8]
    mov edx, [ebx+12]
    add eax, esi
    adc edx, edi
    test edi, edi
    jz l_pg_321
      mov esi, -1
    l_pg_321:
    test edx, edx
    jz l_pg_322
      mov eax, -1
    l_pg_322:
    cmp eax, mt_done
    jna l_pg_38
      cmp esi, mt_done
      jnb l_pg_323
        mov esi, mt_done
      l_pg_323:
      push ecx
        dec esi
        mov edx, 4095
        or esi, edx
        inc esi
        or eax, edx
        xor eax, edx
        push esi
          push eax
            mov edi, esi
            mov esi, mt_done
            shr edi, 12
            shr esi, 12
            mov ah, 1
            call m_set_bitmap
          pop edi
        pop esi
        mov mt_done, edi
        shr esi, 12
        shr edi, 12
        mov ah, 0
        call m_set_bitmap
      pop ecx

  l_pg_38:
  add ebx, M_INFO_ENTRYSIZE
  loop l_pg_31

// <-- Prepare Memory Allocation

// Prepare Paging

// Fill PageTableSystem (PT_SYS)
mov edi, PA_PT_SYS
mov esi, edi  // esi = PA_PT_SYS
mov eax, PG_MASK_P | PG_MASK_W | PG_MASK_G
mov ecx, 1024
cld
l_ppg_1:
 stosd
 add eax, 0x1000
 loop l_ppg_1

// Fill PageTableVar (PT_VAR)
mov edi, PA_PT_VAR
mov edx, edi  // edx = PA_PT_VAR
xor eax, eax
mov ecx, 1024
cld
rep stosd

// Fill PageDirectory0 (PD0)
mov edi, PA_PD0
mov ebx, edi  // ebx = PA_PD0
xor eax, eax
mov ecx, 1024
cld
rep stosd

mov eax, esi  // eax = PA_PT_SYS
or al, PG_MASK_P | PG_MASK_W
mov [ebx], eax
or eax, PG_MASK_G
mov [ebx + (VA_SYSTEM >> 20)], eax

mov eax, edx  // eax = PA_PT_VAR
or al, PG_MASK_P | PG_MASK_W
mov [ebx + (VA_VAR >> 20)], eax

// Enable Paging

mov ecx, PA_PD0
mov cr3, ecx

mov eax, cr0
or eax, 0x80000000
mov cr0, eax

jmp short l_pg_enable_1
l_pg_enable_1:

jmp far SELECTOR_SETUP_CODE:offset l_pg_enable_2
l_pg_enable_2:

// Adjust Paging -->

// Update descriptors 10 18 40 48: base += VA_SYSTEM
mov ax, SELECTOR_KERNEL_DATA
mov ds, ax
mov ebx, PA_GDT
mov al, VA_SYSTEM >> 24  // al = 0xF0
mov [ebx + SELECTOR_KERNEL_CODE + 7], al
mov [ebx + SELECTOR_KERNEL_DATA + 7], al
mov [ebx + SELECTOR_VIDEO + 7], al
mov [ebx + SELECTOR_TEXTVIDEO + 7], al
mov [ebx + SELECTOR_TSS + 7], al
mov [ebx + SELECTOR_LDT + 7], al

// Load updated segments: 0 -> VA_SYSTEM
mov dx, SELECTOR_KERNEL_DATA
mov ds, dx
mov ss, dx  // ds = ss = KERNEL_DATA
mov bx, SELECTOR_ALL_DATA
mov es, bx  // es = fs = gs = ALLMEM
mov fs, bx
mov gs, bx

// Update IDTR, GDTR

jmp short l_adjust_paging_5

idt_48b: dw 2047, (VA_SYSTEM + PA_IDT) & 65535, (VA_SYSTEM + PA_IDT) >> 16
gdt_48b: dw SIZE_GDT-1, (VA_SYSTEM + PA_GDT) & 65535, (VA_SYSTEM + PA_GDT) >> 16

l_adjust_paging_5:
lidt [cs:offset idt_48b]
lgdt [cs:offset gdt_48b]

// LDT
mov edx, SELECTOR_LDT
lldt dx
// <-- Adjust Paging

// Start Kernel

int START_SYSTEM_INT

l_setup_die: jmp l_setup_die

// IN: esi = first frame number, edi = frame after, ah = 0 | 1
// DESTROY: eax, ecx, edx, esi, edi
m_set_bitmap:
// assume: ds = es = 0, m_bitmap_base, m_bitmap_size

// Check indexes to bitmap size
mov edx, m_bitmap_size
shl edx, 3
cmp esi, edx
jna l_m_set_bitmap_11
  mov esi, edx
l_m_set_bitmap_11:
cmp edi, edx
jna l_m_set_bitmap_12
  mov edi, edx
l_m_set_bitmap_12:
cmp esi, edi
jb l_m_set_bitmap_13
  mov al, 1
  ret

l_m_set_bitmap_13:
dec edi

// First byte bitmap
mov ecx, esi
mov dl, 255
and cl, 7
shl dl, cl

// Last byte bitmap
mov ecx, edi
mov dh, 255
and cl, 7
xor cl, 7
shr dh, cl

shr esi, 3
shr edi, 3
mov ecx, m_bitmap_base
add esi, ecx
add edi, ecx
cmp esi, edi
jnz l_m_set_bitmap_5
  // First byte = last byte
  and dl, dh
  test ah, ah
  jnz l_m_set_bitmap_3
    // Clear
    not dl
    and byte[esi], dl
    mov al, 0
    ret

  l_m_set_bitmap_3:
    // Set
    or byte[esi], dl
    mov al, 0
    ret

l_m_set_bitmap_5:
  // First byte <> last byte
  mov ecx, edi
  sub ecx, esi
  dec ecx
  xchg esi, edi
  test ah, ah
  jnz l_m_set_bitmap_6
    // Clear
    not dx
    and byte[edi], dl
    and byte[esi], dh
    mov al, 0
    inc edi
    cld
    rep stosb
    ret

  l_m_set_bitmap_6:
    // Set
    or byte[edi], dl
    or byte[esi], dh
    mov al, 255
    inc edi
    cld
    rep stosb
    mov al, 0
ret

// IN: dl = x, dh = y
// DESTROY: ax, cx, dx
cursorto:
mov al, dh
mov ah, 80
mul ah
add al, dl
adc ah, 0
mov cx, ax
mov dx, 3D4h
mov al, 0Fh
out dx, al
mov al, cl
inc dx
out dx, al
dec dx
mov al, 0Eh
out dx, al
mov al, ch
inc dx
out dx, al
ret

TSCR_W = 80
TSCR_H = 25

// IN: cs:esi->string, cur_pos, ds = KERNEL_DATA
// OUT: cur_pos
writec:
push es
 push edi
  push edx
   push ecx
    push eax

mov cx, SELECTOR_TEXTVIDEO
mov es, cx

mov dx, cur_pos
call writec_calc

l_writec_1:
  mov al, [cs:esi]
  inc esi
  cmp al, 0
  jz l_writec_9
    cmp al, 13
    jz l_writec_1  // ignore CR

    cmp al, 10  // LF = new line
    jnz l_writec_3
      xor dl, dl
      inc dh
      cmp dh, TSCR_H
      jnb l_writec_2
        call writec_calc
        jmp l_writec_1
      
      l_writec_2:
      call writec_over_screen
      jmp l_writec_1
      
    l_writec_3:
    stosb
    inc edi  // skip color
    inc dl
    cmp dl, TSCR_W
    jb l_writec_1
    
    xor dl, dl
    inc dh
    cmp dh, TSCR_H
    jb l_writec_1
    
    call writec_over_screen
    jmp l_writec_1

l_writec_9:
mov cur_pos, dx
call cursorto

    pop eax
   pop ecx
  pop edx
 pop edi
pop es
ret

// IN: dl = curx, dh = cury
// OUT: edi
writec_calc:
push edx
  movzx eax, dh
  mov edi, 80
  mul edi  // eax = dh * 80
pop edx
add al, dl
adc ah, 0
shl eax, 1
mov edi, eax  // edi = (dh * 80 + dl) * 2
ret

// IN: dl, dh, es = SELECTOR_TEXTVIDEO
// OUT: dl, dh, edi
writec_over_screen:  // also used by s_write
dec dh
push esi
 push ecx
  push ds
    push es
    pop ds
    mov esi, TSCR_W * 2
    xor edi, edi
    mov ecx, TSCR_W * (TSCR_H - 1) * 2 / 4
    cld
    rep movsd
    mov ax, 0x0720
    mov ecx, TSCR_W
    rep stosw
  pop ds
 pop ecx
pop esi
mov edi, TSCR_W * (TSCR_H - 1) * 2
ret

LASTOFFSET:
