dos_header:

db "MZ"

dw 0, 1, 0, 4/*Header size in paragraphs*/, 0, 0
dw 0, 0xFFFE  // stack
dw 0  // csum
dw offset dos_main, 0  // ip, cs
dw 0, 0
dw 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 0, 0
dd offset pe_header  // lfanew

[bits 16]

dos_str: db "Requires 32 bit OS\0"

dos_writez:

l_dos_writez_1:
  mov al, [cs:si]
  inc si
  or al, al
  jz l_dos_writez_9
    mov ah, 0Eh
    xor bh, bh
    int 10h
    jmp l_dos_writez_1

l_dos_writez_9:
ret


dos_main:
mov si, offset dos_str
call dos_writez

dos_end:
mov ax, 4C00h
int 21h

MAX_PATH = 260

// Error Codes
ERC_HARDWARE            = 2
ERC_OUT_OF_RANGE        = 5
ERC_DISK_CHANGED        = 6
ERC_NOT_FLUSHED         = 7
ERC_DISK_IO             = 8
ERC_INVALID_DISK_NUMBER = 10h
ERC_NOT_FOUND_IN_CACHE  = 12h  // internal
ERC_UNKNOWN_GEOMETRY    = 15h
ERC_DISK_FULL           = 16h

ERC_INVALID_CHANNEL_NUMBER = 18h
ERC_INVALID_MEMORY_ADDRESS = 19h
ERC_INVALID_COUNT          = 1Ah

ERC_NOT_ENOUGH_MEMORY = 21h
ERC_ALIGN             = 24h
ERC_ALREADY_FREE      = 25h
ERC_OVERFLOW          = 26h
ERC_UNDERFLOW         = 27h

ERC_MSG_QUEUE_EMPTY    = 30h
ERC_MSG_QUEUE_FULL     = 31h
ERC_MSG_INVALID_TARGET = 32h

ERC_TOO_MANY_WINDOWS = 33h
ERC_INVALID_WINDOW   = 34h
ERC_CANT_MOVESIZE    = 35h
ERC_UNKNOWN_CLASS    = 36h

ERC_TOO_MANY_PROCS   = 40h
ERC_TOO_MANY_THREADS = 41h

ERC_TIMER_FULL      = 42
ERC_TIMER_NOT_FOUND = 43

ERC_PATH_NOT_FOUND = 44h
ERC_FILE_NOT_FOUND = 45h
ERC_TOO_MANY_OPEN_FILES = 46h
ERC_DIR_ALREADY_EXISTS = 47h
ERC_UNKNOWN_FILESYSTEM = 48h
ERC_DIR_NOT_EMPTY = 49h
ERC_CANT_REMOVE = 4Ah
ERC_DUPLICATE_NAME = 4Bh
ERC_INVALID_FHANDLE = 4Ch
ERC_INVALID_THREAD = 4Dh
ERC_FS = 4Eh
ERC_READ_ONLY = 4Fh
ERC_IN_USE = 50h
ERC_OUT_OF_DISK = 51h
ERC_TOO_MANY_SEARCHES = 52h
ERC_INVALID_SHANDLE = 53h
ERC_CANT_RENAME = 54h

ERC_INVALID_PID = 55h
ERC_STACK_OVERFLOW = 56h
ERC_PE_INVALID_HEADER = 57h
ERC_INVALID_SERVICE = 58h

ERC_TOO_LONG = 59h
ERC_ONLY_STARTER = 5Ah
ERC_INVALID_MEMORY_LOCATION = 5Bh
ERC_INVALID_THREADID = 5Ch
ERC_ACCESS_DENIED = 5Dh
ERC_INVALID_PRIORITY = 5Eh
ERC_INVALID_ATRBS = 5Fh
ERC_INVALID_VALUE = 60h
ERC_INVALID_POINTER = 61h
ERC_INVALID_CHAR = 62h
ERC_DISK_REMOVED = 63h
ERC_TOO_BIG_HOLE = 64h  // internal
ERC_UTF8 = 65h
ERC_BUSY = 66h
ERC_DIR_TOO_BIG = 67h
ERC_LINK = 68h  // internal
ERC_NOT_A_LINK = 69h
ERC_INFINITE_LINK = 70h
ERC_CANT_MOVE = 71h
ERC_FILE_TOO_BIG = 72h
ERC_NOT_FIT_IN_MFT = 73h
ERC_INVALID_LINK = 74h

ERC_PE_IMPORT_DEPTH_OVERFLOW = 75h
ERC_PE_INVALID_ADR = 76h
ERC_PE_NOT_FOUND = 77h
ERC_PE_ORDINAL = 78h

ERC_INVALID_IMAGE = 79h

ERC_NOT_IMPLEMENTED     = 0FFh

// Window = 32 B (winid)
struct WinRec{
  int2 x, y, w, h
  uns4 flags, cr3, hwnd, pbitmap, pid
  uns1 kbd, parent
  uns1 ncheight, desktop
}

// Window Ex (hwnd)
struct WindowExRec{
  uns4 next, prev, first_child, pmenu, ptext, pclass, menusx
  int2 x, y, w, h
  uns4 winid, pid, hinstance
  uns4 exstyle, style, id, parent, wndproc
}

struct WndClassRec{
  int4 cbSize
  uns4 style
  ptr4 lpfnWndProc
  int4 cbClsExtra
  int4 cbWndExtra
  uns4 hInstance
  ptr4 hIcon
  ptr4 hCursor
  uns4 hbrBackground
  ptr4 lpszMenuName
  ptr4 lpszClassName
  ptr4 hIconSm
  ptr4 next // only tryskos
}

struct PointRec{
  int4 x, y
}

struct MessageRec{
  ptr4 hwnd
  uns4 message
  uns4 wParam
  uns4 lParam
  uns4 time
  PointRec pt
}

struct DCRec{
  int2 x0, y0, x1, y1, x2, y2, x, y
  ptr4 pbitmap, pen, brush, rgn, font, lppaintstruct
  uns4 textcolor
}

struct RectRec{
  int4 left, top, right, bottom
}

GDIOBJ_PEN = 1
GDIOBJ_BRUSH = 2
GDIOBJ_RGN = 3
GDIOBJ_FONT = 4

struct PenRec{
  uns4 type, color, size
}

struct BrushRec{
  uns4 type, flags, color1, color2, pbrushfn
  int2 x1, y1, x2, y2
}

struct RgnRec{
  uns4 type, flags
  int2 left, top, right, bottom
}

struct FontRec{
  uns4 type, rotation, pfont
  bool bold, italics, underline, strike
  char name[64]
}

struct PaintStruct {
	ptr4 hdc; // 0
	uns4 fErase; // 4
	RectRec rcPaint; // 8
	uns4 fRestore; // 24
	uns4 fIncUpdate; // 28
	uns1 rgbReserved[32]; // 32
}

// BitBlt
BLACKNESS = 0x42
NOTSRCERASE = 0x1100A6
NOTSRCCOPY = 0x330008
SRCERASE = 0x440328
DSTINVERT = 0x550009
PATINVERT = 0x5A0049
SRCINVERT = 0x660046
SRCAND = 0x8800C6
MERGEPAINT = 0xBB0226
MERGECOPY = 0xC000CA
SRCCOPY = 0xCC0020
SRCMERGE = 0xDD0022
SRCPAINT = 0xEE0086
WHITENESS = 0xFF0062

// GetStockObject
BLACK_BRUSH = 4
DKGRAY_BRUSH = 3
GRAY_BRUSH = 2
HOLLOW_BRUSH = 5
LTGRAY_BRUSH = 1
NULL_BRUSH = 5
WHITE_BRUSH = 0
BLACK_PEN = 7
NULL_PEN = 8
WHITE_PEN = 6
ANSI_FIXED_FONT = 11
ANSI_VAR_FONT = 12
DEVICE_DEFAULT_FONT = 14
DEFAULT_GUI_FONT = 17
OEM_FIXED_FONT = 10
SYSTEM_FONT = 13
SYSTEM_FIXED_FONT = 16
DEFAULT_PALETTE = 15

struct DateTime8{
  uns8 datetime
}

struct SearchRec{
  uns4 FileAttributes
  DateTime8 CreationTime
  DateTime8 LastAccessTime
  DateTime8 LastWriteTime
  uns8 FileSize
  uns8 Reserved
  char FileName[MAX_PATH]
  char AlternateFileName[14]
}

struct SystemTime{
  uns2 wYear
  uns2 wMonth
  uns2 wDayOfWeek
  uns2 wDay
  uns2 wHour
  uns2 wMinute
  uns2 wSecond
  uns2 wMilliseconds
}

MAX_WIN = 255
WIN_NONE = 255
WIN_MAINPANELH = 0
WIN_HEADER = 16
WIN_BORDER = 6
WIN_CORNER = 16
WIN_MINW = 64 + (WIN_BORDER * 2)
WIN_MINH = WIN_HEADER + (WIN_BORDER * 2)
WIN_MENUH = 16

WIN_DEFAULT_X_STEP = 32
WIN_DEFAULT_Y_STEP = 32
WIN_DEFAULT_X_MAX = 250
WIN_DEFAULT_Y_MAX = 250
WIN_BORDERCOLOR = 0xFF0080FF
WIN_HEADERCOLOR = 0xFF0080FF
WIN_FRAMECOLOR = 0xFF000000
WIN_ACTIVEFRAMECOLOR = 0xFFFFFF00
WIN_CLOSECOLOR = 0xFFE04040
WIN_MAXIMIZECOLOR = 0xFFA0A0A0
WIN_LIGHT = 0xFFFFFFFF
WIN_DARK = 0xFF606060

WINFLAGS_VALID = 1
WINFLAGS_FULLSCREEN = 2
WINFLAGS_ALWAYSONTOP = 8
WINFLAGS_CLOSEPRESSED    = 0x10
WINFLAGS_MAXIMIZEPRESSED = 0x20
WINFLAGS_MINIMIZEPRESSED = 0x40

// wp of mousemove
MK_LBUTTON  = 0x0001
MK_RBUTTON  = 0x0002
MK_SHIFT    = 0x0004
MK_CONTROL  = 0x0008
MK_MBUTTON  = 0x0010
MK_XBUTTON1 = 0x0020
MK_XBUTTON2 = 0x0040

WS_TABSTOP     = 0x00010000
WS_MAXIMIZEBOX = 0x00010000
WS_GROUP       = 0x00020000
WS_MINIMIZEBOX = 0x00020000
WS_SIZEBOX     = 0x00040000
WS_SYSMENU     = 0x00080000
WS_HSCROLL     = 0x00100000
WS_VSCROLL     = 0x00200000
WS_DLGFRAME    = 0x00400000
WS_BORDER      = 0x00800000
WS_CAPTION     = 0x00C00000
WS_MAXIMIZE    = 0x01000000
WS_DISABLED    = 0x08000000
WS_VISIBLE     = 0x10000000
WS_MINIMIZE    = 0x20000000
WS_CHILD       = 0x40000000
WS_POPUP       = 0x80000000
WS_OVERLAPPEDWINDOW = WS_CAPTION | WS_SYSMENU | WS_SIZEBOX | WS_MINIMIZEBOX | WS_MAXIMIZEBOX
WS_POPUPWINDOW = WS_POPUP | WS_BORDER | WS_SYSMENU

CW_USEDEFAULT = -1

SWP_NOSIZE = 1
SWP_NOMOVE = 2
SWP_NOZORDER = 4
SWP_NOREDRAW = 8
SWP_NOACTIVATE = 0x10
SWP_DRAWFRAME = 0x20
SWP_FRAMECHANGED = 0x20
SWP_SHOWWINDOW = 0x40
SWP_HIDEWINDOW = 0x80
SWP_NOCOPYBITS = 0x100
SWP_NOOWNERZORDER = 0x200
SWP_NOREPOSITION = 0x200
SWP_NOSENDCHANGING = 0x400
SWP_RELSIZE = 0x1000
SWP_RELMOVE = 0x2000

SW_HIDE = 0
SW_NORMAL = 1
SW_MAXIMIZE = 3
SW_SHOW = 5
SW_MINIMIZE = 6
SW_RESTORE = 9

RDW_INVALIDATE = 1
RDW_INTERNALPAINT = 2
RDW_ERASE = 4
RDW_VALIDATE = 8
RDW_NOINTERNALPAINT = 16
RDW_NOERASE = 32
RDW_NOCHILDREN = 64
RDW_ALLCHILDREN = 128
RDW_UPDATENOW = 256
RDW_ERASENOW = 512
RDW_FRAME = 1024
RDW_NOFRAME = 2048

WM_NULL = 0
WM_CREATE = 1
WM_DESTROY = 2
WM_MOVE = 3
WM_SIZE = 5
WM_ACTIVATE = 6
WM_SETFOCUS = 7
WM_KILLFOCUS = 8
WM_ENABLE = 10
WM_SETREDRAW = 11
WM_SETTEXT = 12
WM_GETTEXT = 13
WM_GETTEXTLENGTH = 14
WM_PAINT = 15
WM_CLOSE = 16
WM_QUERYENDSESSION = 17
WM_QUIT = 18
WM_QUERYOPEN = 19
WM_ERASEBKGND = 20
WM_SYSCOLORCHANGE = 21
WM_ENDSESSION = 22
WM_SHOWWINDOW = 24
WM_WINDOWPOSCHANGED = 47h
WM_NCPAINT = 85h
WM_NCMOUSEMOVE = 0A0h
WM_NCLBUTTONDOWN = 0A1h
WM_NCLBUTTONUP = 0A2h
WM_NCLBUTTONDBLCLK = 0A3h
WM_NCRBUTTONDOWN = 0A4h
WM_NCRBUTTONUP = 0A5h
WM_NCRBUTTONDBLCLK = 0A6h
WM_NCMBUTTONDOWN = 0A7h
WM_NCMBUTTONUP = 0A8h
WM_NCMBUTTONDBLCLK = 0A9h
WM_NCXBUTTONDOWN = 0ABh
WM_NCXBUTTONUP = 0ACh
WM_NCXBUTTONDBLCLK = 0ADh
WM_KEYDOWN    = 100h
WM_KEYUP      = 101h
WM_CHAR       = 102h
WM_SYSKEYDOWN = 104h
WM_SYSKEYUP   = 105h
WM_COMMAND = 111h
WM_TIMER   = 113h
WM_TERMINATED   = 180h
WM_NEW_CLIP     = 181h
WM_WINDOWCLOSED = 182h
WM_SCROLL       = 183h
WM_MOUSEBUTTON  = 184h
WM_MAINPANELHCHANGED = 185h
WM_NCMOUSEOVER  = 186h
WM_CHARIO       = 187h
WM_PAINTBUTTONS = 188h
WM_MOUSEOVER    = 189h
WM_DISKCHANGED  = 18Ah
WM_USB_INT = 1A0h
WM_MOUSEMOVE = 200h
WM_LBUTTONDOWN = 201h
WM_LBUTTONUP = 202h
WM_LBUTTONDBLCLK = 203h
WM_RBUTTONDOWN = 204h
WM_RBUTTONUP = 205h
WM_RBUTTONDBLCLK = 206h
WM_MBUTTONDOWN = 207h
WM_MBUTTONUP = 208h
WM_MBUTTONDBLCLK = 209h
WM_MOUSEWHEEL = 20Ah
WM_XBUTTONDOWN = 20Bh
WM_XBUTTONUP = 20Ch
WM_XBUTTONDBLCLK = 20Dh
WM_MOUSEHWHEEL = 20Eh
WM_DEVICECHANGE = 219h

IMAGE_BASE = 0x7DC50000

COFS = IMAGE_BASE + 0x1000 - 0x400
CRVA = 0x1000 - 0x400

IMG_ID_BITMAP = 0
IMG_ID_ICON = 1
IMG_ID_CURSOR = 2

VK_LEFT = 37
VK_RIGHT = 39
VK_UP = 38
VK_DOWN = 40
VK_ENTER = 13
VK_ESC = 27
VK_BSP = 8
VK_TAB = 9
VK_HOME = 36
VK_END = 35
VK_PGUP = 33
VK_PGDN = 34
VK_INS = 45
VK_DEL = 46

KBD_RSH  = 1
KBD_LSH  = 2
KBD_CTRL = 4
KBD_ALT  = 8
KBD_SCRLK = 0x10
KBD_NUMLK = 0x20
KBD_CPSLK = 0x40
KBD_INS   = 0x80
KBD_RCTRL = 0x400
KBD_RALT  = 0x800
KBD_VCTRL = 0x1000

FOPEN_READ = 1
FOPEN_WRITE = 3
FOPEN_APPEND = 10h
FOPEN_CREATE = 20h

FILE_ATTRIBUTE_READONLY  = 0x00000001
FILE_ATTRIBUTE_HIDDEN    = 0x00000002
FILE_ATTRIBUTE_SYSTEM    = 0x00000004
FILE_ATTRIBUTE_DIRECTORY = 0x00000010
FILE_ATTRIBUTE_ARCHIVE   = 0x00000020
FILE_ATTRIBUTE_DEVICE    = 0x00000040
FILE_ATTRIBUTE_NORMAL    = 0x00000080
FILE_ATTRIBUTE_TEMPORARY     = 0x00000100
FILE_ATTRIBUTE_SPARSE_FILE   = 0x00000200
FILE_ATTRIBUTE_REPARSE_POINT = 0x00000400
FILE_ATTRIBUTE_COMPRESSED    = 0x00000800
FILE_ATTRIBUTE_OFFLINE       = 0x00001000
FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = 0x00002000
FILE_ATTRIBUTE_ENCRYPTED       = 0x00004000
FILE_ATTRIBUTE_VALID_FLAGS     = 0x00007fb7
FILE_ATTRIBUTE_VALID_SET_FLAGS = 0x000031a7
FILE_ATTRIBUTE_LINUX = 0x08000000
FILE_ATTRIBUTE_LINK  = 0x04000000

ACCESS_R = 4 //read
ACCESS_W = 2 //write
ACCESS_X = 1 //execute

FSID_EXT2 = 82h
FSID_NTFS = 7
FSID_FAT12 = 0F0h
FSID_CD = 30h

EXT2_FEATURE_RO_COMPAT_SPARSE_SUPER = 0x0001 // Sparse Superblock
EXT2_FEATURE_RO_COMPAT_LARGE_FILE = 0x0002   // 64-bit file size
EXT2_FEATURE_RO_COMPAT_BTREE_DIR = 0x0004    // Binary tree sorted directories

struct StringBuilder{
  uns4 len, max
  ptr4 data
}

struct WindowPosRec {
  uns4 hwnd
  uns4 hwndInsertAfter
  int4 x, y, cx, cy
  uns4 flags
}

struct CreateRec{
  ptr4 lpCreateParams
  uns4 hInstance
  uns4 hMenu
  uns4 hwndParent
  int4 cy, cx, y, x
  uns4 style
  ptr4 lpszName
  ptr4 lpszClass
  uns4 dwExStyle
}

struct IconDir{
  uns2 zero, type, number
}

struct IconDirEntry{
  uns1 w, h, palette, rsv1
  uns2 planes, bpp  // Cursor: hotspotx, hotspoty
  uns4 size, ofs
}

struct BitmapFileHeader{
  uns2 magic // = "BM"
  uns4 size
  uns2 rsv1, rsv2
  uns4 ofs
}

struct BitmapInfoHeader{
  uns4 header_size  // 40
  int4 w, h
  uns2 planes, bpp
  uns4 compression_method, size
  int4 resx, resy
  uns4 palette, important
}

struct ImageCache{
  uns4 next, ptr, hinst
  char name[MAX_PATH]
}

[dorg 0x7DC58000]

uns8 num, time
uns4 time_zone

ptr4 regclass

WinRec win1

MessageRec msg

int2 ux1, uy1, ux2, uy2  // window coords

uns1 lasterror

[dalign 16]
IconDir icon_dir

[dalign 32]
IconDirEntry icon_dir_entry
BitmapFileHeader bmp_fheader
BitmapInfoHeader bmp_info_header
uns4 first_cache, img_w, img_h, img_colors
uns2 img_id
uns1 img_i
bool img_busy, img_doflip

[align 32]

pe_header:

db "PE"

dw 0, 14Ch, 2/*Number of sections*/
dd 0, 0/*Pointer to symbol table*/, 0/*Number of symbols*/
dw 224 /*Size of optional header*/, 0 /*Characteristics*/

// Optional header
dw 0/*OH magic*/

db 0, 0
dd offset lastoffset /*Size of code*/
dd 0/*Size of initialized data*/, # - 0x7DC58000/*Size of uninitialized data*/
dd offset main + CRVA/*Address of entry point*/
dd 0/*Base of code*/, 0x10000/*Base of data*/

dd IMAGE_BASE/*Image base*/
dd 0x1000 /*Section alignment*/, 0x200 /*File alignment*/
dw 4, 0 /*OS version*/, 0, 0 /*Image version*/, 4, 0 /*Subsystem version*/
dd 0, 0x10000/*Size of image*/, 0x400/*Size of headers*/
dd 0 /*Checksum*/
dw 1/*Subsystem*/, 0/*DLL characteristics*/
dd 0x100000/*stack*/, 0x1000
dd 0x100000/*heap*/, 0x1000
dd 0/*Loader flags*/, 16/*RVA and sizes*/

// export
dd offset export + CRVA, 0x1000 // !!! offset export_lastoffset - offset export
// import
dd offset import + CRVA, 0x1000 // !!! offset import_lastoffset - offset import
// other directories
dd 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0

// Section table [lfanew + 18h + sizeOfOptionalHeader]
db ".text   "
dd offset lastoffset // VSize
dd 0x1000 // RVA
dd offset lastoffset // Size of raw data
dd 0x400 // Pointer to raw data
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0x60000060 // Characteristics

db ".data   "
dd # - 0x7DC58000 // VSize
dd 0x8000 // RVA
dd 0 // Size of raw data
dd 0 // Pointer to raw data
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0xC0000040 // Characteristics

times 0x400 - $, 0

[bits 32]

jmp main

// IN: dl = x, dh = y
curto:
push ecx
 push esi
  push edx
   push edi
    push ebx
  
     mov ah, 3
     int 20h
  
    pop ebx
   pop edi
  pop edx
 pop esi
pop ecx
ret

// IN: esi -> string, ecx = length, bl = color
write:
push edx
 push edi
  push ebx
  
  mov ah, 2
  int 20h
  
  pop ebx
 pop edi
pop edx
ret

// IN: eax = number, ecx = system, bl = color
writen:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writen_1
		mov ecx, 10		// ecx must be >= 2

	l_writen_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writen_2
			add dl, '0'
			jmp short l_writen_3

		l_writen_2:
			add dl, 55

		l_writen_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writen_1
	
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
      dec esi
      inc ecx
      mov [esi], dl
      
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

// IN: eax = number, ecx = system, bl = color, bh = minlen
writemin:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writemin_1
		mov ecx, 10		// ecx must be >= 2

	l_writemin_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writemin_2
			add dl, '0'
			jmp short l_writemin_3

		l_writemin_2:
			add dl, 55

		l_writemin_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writemin_1
	
	cmp bh, 36
	jb l_writemin_4
	  mov bh, 36
	  
	l_writemin_4:
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
	l_writemin_5:
	  cmp cl, bh
	  jnb l_writemin_6
          dec esi
          inc ecx
          mov [esi], dl
          jmp short l_writemin_5
      
	l_writemin_6:	  
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

THOUSAND_SEPARATOR = ','

// IN: edx:eax = number, ecx = system, bl = color
writen8:
push ecx
 push esi
  push edi

    sub esp, 72

    // Parse digits from the number
    mov esi, esp
    add esi, 72

    mov dword ptr num[0], eax
    mov dword ptr num[4], edx
    xor bh, bh

    cmp ecx, 2
    jnb l_writen8_1
      mov ecx, 10		// ecx must be >= 2
    
    l_writen8_1:
      cmp bh, 3
      jb l_writen_12
        dec esi
        mov byte ptr [esi], THOUSAND_SEPARATOR
        xor bh, bh
        
      l_writen_12:
      inc bh
      xor edx, edx
      mov eax, dword ptr num[4]
      div ecx
      mov dword ptr num[4], eax
      mov eax, dword ptr num[0]
      div ecx
      mov dword ptr num[0], eax
      
      cmp dl, 10
      jnb l_writen8_2
        add dl, '0'
        jmp short l_writen8_3
      
      l_writen8_2:
        add dl, 55
      
      l_writen8_3:
      dec esi
      mov [esi], dl
      
      mov eax, dword ptr num[0]
      mov edx, dword ptr num[4]
      test eax, eax
      jnz l_writen8_1
        test edx, edx
        jnz l_writen8_1
      
    mov ecx, esp
    add ecx, 72
    sub ecx, esi  // ecx = len
    mov dl, ' '
    
    dec esi
    inc ecx
    mov [esi], dl
     
    call write
     
    add esp, 72
    
  pop edi
 pop esi
pop ecx
ret

// IN: edx -> path & mask, edi -> SearchRec
// OUT: al = 0 || erc
find_first:
mov ah, 22
int 20h
cmp al, ERC_BUSY
jnz l_find_first_9
  call noop
  jmp short find_first
  
l_find_first_9:
ret

// IN: edi -> SearchRec
// OUT: al = 0 || erc
find_next:
mov ah, 23
int 20h
cmp al, ERC_BUSY
jnz l_find_next_9
  call noop
  jmp short find_next
  
l_find_next_9:
ret

// IN: edi -> SearchRec
find_close:
mov ah, 48
int 20h
ret

// IN: edx -> pathz
cdir:
mov ah, 16
int 20h
cmp al, ERC_BUSY
jnz l_cdir_9
  call noop
  jmp short cdir
  
l_cdir_9:
ret

// IN: edi -> buffer[MAX_PATH]
// OUT: al = 0 || erc
get_current_directory:
mov ah, 52
int 20h
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopen:
mov esi, 3
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopen_9
  call noop
  jmp short fopen
  
l_fopen_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopenread:
mov esi, 1
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopenread_9
  call noop
  jmp short fopenread
  
l_fopenread_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fcreate:
mov esi, 20h
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fcreate_9
  call noop
  jmp short fcreate
  
l_fcreate_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fpos
fgetpos:
mov ah, 14
int 20h
cmp al, ERC_BUSY
jnz l_fgetpos_9
  call noop
  jmp short fgetpos
  
l_fgetpos_9:
ret

// IN: ebx = fhandle, edx:edi = file offset
// OUT: al = erc
fsetpos:
mov ah, 12
int 20h
cmp al, ERC_BUSY
jnz l_fsetpos_9
  call noop
  jmp short fsetpos
  
l_fsetpos_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fsize
fgetsize:
mov ah, 15
int 20h
cmp al, ERC_BUSY
jnz l_fgetsize_9
  call noop
  jmp short fgetsize
  
l_fgetsize_9:
ret

// IN: ebx = fhandle
fclose:
mov ah, 9
int 20h
cmp al, ERC_BUSY
jnz l_fclose_9
  call noop
  jmp short fclose
  
l_fclose_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size read
fread:
mov ah, 10
int 20h
cmp al, ERC_BUSY
jnz l_fread_9
  call noop
  jmp short fread
  
l_fread_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size write
fwrite:
mov ah, 11
int 20h
cmp al, ERC_BUSY
jnz l_fwrite_9
  call noop
  jmp short fwrite
  
l_fwrite_9:
ret

// IN: edx -> filenamez
rm:
mov ah, 18
int 20h
cmp al, ERC_BUSY
jnz l_rm_9
  call noop
  jmp short rm
  
l_rm_9:
ret

// IN: edx -> filenamez
md:
mov ah, 17
int 20h
cmp al, ERC_BUSY
jnz l_md_9
  call noop
  jmp short md
  
l_md_9:
ret

// IN: edx -> path & filenamez, esi -> new filenamez
// OUT: al = erc
ren:
mov ah, 20
int 20h
cmp al, ERC_BUSY
jnz l_ren_9
  call noop
  jmp short ren
  
l_ren_9:
ret

// IN: edx -> filenamez, esi -> new path
mv:
mov ah, 21
int 20h
cmp al, ERC_BUSY
jnz l_mv_9
  call noop
  jmp short mv
  
l_mv_9:
ret

// IN: esi = ldiskn
resetdisk:
mov ah, 63
int 20h
ret

// IN: edx -> filenamez, esi = mode
// OUT: al = erc, ebx = fhandle
open_link:
mov ah, 66
int 20h
cmp al, ERC_BUSY
jnz l_open_link_9
  call noop
  jmp short open_link
  
l_open_link_9:
ret

// IN: edx -> filenamez
// OUT: al = erc
rm_link:
mov ah, 67
int 20h
cmp al, ERC_BUSY
jnz l_rm_link_9
  call noop
  jmp short rm_link
  
l_rm_link_9:
ret

// IN: al = ldiskn
// OUT: al = erc
flush:
movzx esi, al

l_flush_1:
mov ah, 39 
int 20h
cmp al, ERC_BUSY
jnz l_flush_9
  call noop
  jmp short l_flush_1
  
l_flush_9:
ret

// IN: ebx = fhandle
// OUT: al = erc, edx:ecx = ftime
get_mtime:
mov ah, 74
int 20h
cmp al, ERC_BUSY
jnz l_get_mtime_9
  call noop
  jmp short get_mtime
  
l_get_mtime_9:
ret

// IN: ebx = fhandle, edx:ecx = ftime
// OUT: al = erc
set_mtime:
mov ah, 75
int 20h
cmp al, ERC_BUSY
jnz l_set_mtime_9
  call noop
  jmp short set_mtime
  
l_set_mtime_9:
ret

// IN: edx -> filenamez, esi = atrbs
// OUT: al = errorcode
// differrent behavior for windows and linux
chmod:
mov ah, 76
int 20h
cmp al, ERC_BUSY
jnz l_chmod_9
  call noop
  jmp short chmod
  
l_chmod_9:
ret

// only starter, root
// IN: edx -> filenamez, esi = new owner
// OUT: al = erc
chown:
mov ah, 78
int 20h
cmp al, ERC_BUSY
jnz l_chown_9
  call noop
  jmp short chown
  
l_chown_9:
ret

// only starter, root or owner
// IN: edx -> filenamez, esi = new group
// OUT: al = erc
chgrp:
mov ah, 79
int 20h
cmp al, ERC_BUSY
jnz l_chgrp_9
  call noop
  jmp short chgrp
  
l_chgrp_9:
ret

// IN: edx -> filenamez
// OUT: al = erc, ecx = uid, edx = gid
fuidgid:
mov ah, 82
int 20h
cmp al, ERC_BUSY
jnz l_fuidgid_9
  call noop
  jmp short fuidgid
  
l_fuidgid_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> target
disk_read:
mov ah, 36
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_9
  call noop
  jmp short disk_read
  
l_disk_read_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> source
disk_write:
mov ah, 37
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_9
  call noop
  jmp short disk_write
  
l_disk_write_9:
ret

// OUT: al = logical disk number
get_boot_disk:
mov ah, 77
int 20h
movzx eax, al
ret

// OUT: al = logical disk number
get_users_disk:
mov ah, 83
int 20h
movzx eax, al
ret

// IN: esi = logical disk number
// OUT: al = type (2:fd, 3:cd, 4:hd), ah = pdiskn,
//      edx:ecx = disk size in sectors, edi:esi = base in sectors
get_disk_type:
mov ah, 53
int 20h
ret

// IN: esi = logical disk number
// OUT: edx:eax = disk size in bytes
get_disk_size:
mov ah, 38
int 20h
ret

// IN: al = ldiskn
// OUT: cl = erc, edx:eax = free bytes)
disk_free:
mov esi, eax

l_disk_free_1:
mov ah, 68
int 20h
cmp al, ERC_BUSY
jnz l_disk_free_9
  call noop
  jmp short l_disk_free_1
  
l_disk_free_9:
xchg eax, ecx
ret

// IN: al = ldiskn
// OUT: al = erc
reset_disk:
mov esi, eax

l_reset_disk_1:
mov ah, 63
int 20h
cmp al, ERC_BUSY
jnz l_reset_disk_9
  call noop
  jmp short l_reset_disk_1
  
l_reset_disk_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_read_sector:
mov ah, 40
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_sector_9
  call noop
  jmp short disk_read_sector
  
l_disk_read_sector_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_write_sector:
mov ah, 41
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_sector_9
  call noop
  jmp short disk_write_sector
  
l_disk_write_sector_9:
ret

// IN: dl = winid, edi -> WinRec
// OUT: al = erc
getwin:
mov ah, 98
int 20h
ret

// IN: bl = winid, ecx = WM, edx = wp, esi = lp
// OUT: al = errorcode
postmsgwin:
mov ah, 105
int 20h
ret

// IN: dl = winid, dh = 1:alt+tab 2:click
activate:
mov ah, 94
int 20h
ret

// IN: dl = winid
toback:
mov ah, 108
int 20h
ret

// IN: ecx = {int2 x, y}, edx = {int2 w, h}, esi = hwnd, ebx = style/flags
// OUT: al = erc, edx = wdesktop:winid
create:
mov ah, 86
int 20h
ret

// IN: dl = winid
destroy:
mov ah, 87
int 20h
ret

// IN: dl = winid, dh = SW_*
// OUT: al = erc
wshow:
mov ah, 109
int 20h
ret

// IN: ecx = x1, ebx = y1, esi = x2, edi = y2
repaint:
mov ah, 88
int 20h
ret

// IN: dl = winid, cl = pressed button mask (0x10, 0x20, 0x40)
setbuttons:
mov ah, 110
int 20h
ret

noop:
mov ah, 0
int 20h
ret

// IN: ecx = size
// OUT: al = erc, ebx = ptr
malloc:
mov ah, 24
int 20h
ret

// IN: ebx = ptr
free:
mov ah, 25
int 20h
ret

// IN: ecx = size
// OUT: al = errorcode, ebx = ptr to block
gmalloc:
mov ah, 26
int 20h
ret

// IN: ebx = ptr to block
gfree:
mov ah, 27
int 20h
ret

// OUT: ebx = pid, edx = ppid, edi = threadid
getpid:
mov ah, 45
int 20h
ret

// OUT: al = 0 || errorcode, ebx = wnd:sender, ecx = msg, edx = wp, esi = lp
getmsg:
mov ah, 5 // get system message
int 20h
or al, al
jz l_getmsg_9
  mov ah, 7 // get message
  int 20h
  or al, al
  jz l_getmsg_9
    mov ah, 45 // get pid, tid; OUT: edi = tid
    int 20h
    mov ah, 35 // stop thread
    int 20h
    jmp short getmsg
  
l_getmsg_9:
ret

// KEEP: ebx, ebp
waitkey:
push ebx
 push ebp

  l_waitkey_5:
    mov ah, 45 // get pid, tid; OUT: edi = tid
    int 20h
    mov ah, 35 // stop thread
    int 20h
    call getmsg
    cmp ecx, WM_KEYDOWN
    jnz l_waitkey_5

 pop ebp
pop ebx
ret

// IN: esi -> ftime, edi -> SystemTime
ftime2local:
mov eax, time_zone
mov ecx, 3600
imul ecx
mov ecx, 10000000
imul ecx

add eax, [esi]
adc edx, [esi + 4]
mov dword ptr time[0], eax
mov dword ptr time[4], edx

mov esi, offset time
mov ah, 59
int 20h
ret

// IN: ecx = uid, edi -> byte[256]
getuserinfo:
mov ah, 80
int 20h
cmp al, ERC_BUSY
jnz l_getuserinfo_9
  call noop
  jmp short getuserinfo
  
l_getuserinfo_9:
ret

// IN: ecx = gid, edi -> byte[256]
getgroupinfo:
mov ah, 81
int 20h
cmp al, ERC_BUSY
jnz l_getgroupinfo_9
  call noop
  jmp short getgroupinfo
  
l_getgroupinfo_9:
ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_init:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

// IN: esi -> StringBuilder, edi -> data, ecx = len
// OUT: al = erc (0: ok, 1: not enough memory)
// KEEP: esi
sb_add:
mov edx, [esi + offset StringBuilder.max]
mov eax, [esi + offset StringBuilder.len]
add eax, ecx
cmp eax, edx
jna l_sb_add2
  // len + ecx > max
  cmp edx, 16
  jnb l_sb_add11
    mov edx, 16
    
  l_sb_add11:
  cmp eax, edx
  jna l_sb_add14
    shl edx, 1
    cmp edx, 0
    jnz l_sb_add11
      
      l_sb_add13:
      
      mov al, 1
      
      ret
    
  l_sb_add14:
  // allocate a new block
  push esi
   push edi
    push ecx
     push edx
      mov ecx, edx
      call malloc
      // OUT: ebx
     pop edx
    pop ecx
   pop edi
  pop esi
  or al, al
  jnz l_sb_add13
  
  // copy old data to the new block
  mov [esi + offset StringBuilder.max], edx
  push esi
   push edi
    push ecx
     push ebx
       mov ecx, [esi + offset StringBuilder.len]
       mov esi, [esi + offset StringBuilder.data]
       mov edi, ebx
       mov ebx, esi
       cld
       rep movsb
       
       // free the old block
       or ebx, ebx
       jz l_sb_add18
         call free
         
       l_sb_add18:
     pop ebx 
    pop ecx
   pop edi
  pop esi
  mov [esi + offset StringBuilder.data], ebx

l_sb_add2:
// copy data
mov ebx, edi
mov edi, [esi + offset StringBuilder.data]
add edi, [esi + offset StringBuilder.len]
add [esi + offset StringBuilder.len], ecx

push esi
  mov esi, ebx
  cld
  rep movsb
pop esi

mov al, 0

ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_done:
mov ebx, [esi + offset StringBuilder.data]
or ebx, ebx
jz sb_done_2
  
  push esi
  
    call free
  
  pop esi
  
sb_done_2:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

wregs1: db "\n | acdb = "
wregs2: db " | sbsd = "

wregs:
pushad
  mov ebp, esp
  
  mov esi, offset wregs1 + COFS
  mov ecx, 10
  mov bl, 7
  call write
  
  mov eax, [ebp + 28]
  mov ecx, 16
  mov bh, 9
  call writen
  
  mov eax, [ebp + 24]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 20]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 16]
  mov ecx, 16
  call writen
  
  
  mov esi, offset wregs2 + COFS
  mov ecx, 9
  mov bl, 7
  call write
  
  mov eax, [ebp + 12]
  mov ecx, 16
  mov bh, 9
  call writen
  
  mov eax, [ebp + 8]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 4]
  mov ecx, 16
  call writen
  
  mov eax, [ebp + 0]
  mov ecx, 16
  call writen

popad
ret

// IN: esi -> stringz
// OUT: ecx
// KEEP: all but ecx
strlen:
push esi
  xor ecx, ecx
  
  l_strlen_5:
    lodsb
    test al, al
    jz l_strlen_9
      inc ecx
      jmp short l_strlen_5
      
  l_strlen_9:
pop esi
ret

// IN: esi -> str1, edi -> str2, ecx = count
// OUT: al = 0(eq) || 1
strcmp:
cld
repz cmpsb
jz l_strcmp_8
  mov al, 1
  jmp short l_strcmp_9
  
l_strcmp_8:
mov al, 0

l_strcmp_9:
ret

// IN: edi = hwnd, ecx = message, edx = wp, esi = lp
// OUT: al = erc
postmsg:
test edi, edi
jz l_postmsg_2
  movzx ebx, byte ptr [edi + offset WindowExRec.winid]
  jmp short l_postmsg_6
  
l_postmsg_2:
mov ebx, WIN_NONE

l_postmsg_6:
shl ebx, 16
push ebx
 push ecx
  push edx
   push esi
    mov ah, 45 // get pid, tid; OUT: edi = tid
    int 20h
    mov eax, ebx
   pop esi
  pop edx
 pop ecx
pop ebx
mov bx, ax
mov ah, 6 // post message
int 20h
ret

// IN: win1, ebp
// KEEP: edx, esi, edi
checkregion:
mov cx, win1.x
mov bx, win1.y
cmp cx, [ebp - 8]
jnl l_checkregion_34
  mov [ebp - 8], cx
  
l_checkregion_34:
cmp bx, [ebp - 6]
jnl l_checkregion_35
  mov [ebp - 6], bx
  
l_checkregion_35:
add cx, win1.w
add bx, win1.h
dec ecx
dec ebx
cmp cx, [ebp - 4]
jng l_checkregion_36
  mov [ebp - 4], cx
  
l_checkregion_36:
cmp bx, [ebp - 2]
jng l_checkregion_37
  mov [ebp - 2], bx
  
l_checkregion_37:
ret

// IN: win1
// OUT: ecx, ebx, esi, edi
getclient:
xor ecx, ecx
xor ebx, ebx
movsx esi, win1.w
dec esi
movsx edi, win1.h
dec edi

test win1.flags, WS_CAPTION
jz l_getclient_8
  test win1.flags, WS_MAXIMIZE
  jnz l_getclient_8
    // caption, ! maximize
    mov eax, WIN_BORDER
    add ecx, eax
    //add ebx, eax
    sub esi, eax
    sub edi, eax
    
l_getclient_8:
movsx eax, win1.ncheight
add ebx, eax
ret

// IN: esi -> WindowPosRec, edi -> WindowExRec || (winid + 1)
defsetwinpos:
push ebp
mov ebp, esp
sub esp, 2 * 4

// eax = flags
mov eax, [esi + offset WindowPosRec.flags]
// dl = winid
cmp edi, 1
jb l_defsetwinpos_12
  cmp edi, MAX_WIN
  ja l_defsetwinpos_13
    mov edx, edi
    dec edx
    jmp short l_defsetwinpos_14
    
l_defsetwinpos_12:
mov dl, WIN_NONE
jmp short l_defsetwinpos_14

l_defsetwinpos_13:
mov dl, [edi + offset WindowExRec.winid]
  
l_defsetwinpos_14:
test eax, SWP_NOZORDER
jnz l_defsetwinpos_2
  // activate/deactivate
  push eax
   push edx
    push esi
     push edi
      cmp dword ptr [esi + offset WindowPosRec.hwndInsertAfter], 1 // HWND_BOTTOM
      jnz l_defsetwinpos_15
        call toback
        jmp short l_defsetwinpos_18
        
      l_defsetwinpos_15:
        mov dh, 1
        call activate
        
      l_defsetwinpos_18:
     pop edi
    pop esi
   pop edx
  pop eax

l_defsetwinpos_2:
mov word ptr [ebp - 8], 32767
mov word ptr [ebp - 6], 32767
mov word ptr [ebp - 4], -1
mov word ptr [ebp - 2], -1

test eax, SWP_RELSIZE
jz near l_defsetwinpos_29
  // relative resize
  push eax
    push edx
     push esi
       mov edi, offset win1
       call getwin
     pop esi
     movsx eax, win1.w
     movsx edx, win1.h
     add [esi + offset WindowPosRec.cx], eax
     add [esi + offset WindowPosRec.cy], edx
     jmp l_defsetwinpos_22
     
l_defsetwinpos_29:
test eax, SWP_NOSIZE
jnz near l_defsetwinpos_3
  // resize
  push eax
    push edx
     push esi
       mov edi, offset win1
       call getwin
     pop esi
     
     l_defsetwinpos_22:
     push esi
       // wm_size
       mov eax, win1.hwnd
       mov msg.hwnd, eax
       mov msg.message, WM_SIZE
       mov msg.wParam, 0
       mov ax, [esi + offset WindowPosRec.cy]
       shl eax, 16
       mov ax, [esi + offset WindowPosRec.cx]
       mov msg.lParam, eax
       push offset msg
       call dispatchmsg
     pop esi
    pop edx
    push edx
     push esi
       mov edi, offset win1
       call getwin
     pop esi
     call checkregion
     push esi       
       mov ecx, [esi + offset WindowPosRec.cx]
       mov ebx, [esi + offset WindowPosRec.cy]
       mov ah, 101 // wsize
       int 20h
     pop esi
    pop edx
    test al, al
    jnz near l_defsetwinpos_28
      mov edi, offset win1
      push edx
       push esi
        call getwin
       pop esi
      pop edx
      call checkregion
      
      // paint, keep edx, esi
      push edx
       push esi
        // ncpaint
        mov eax, win1.hwnd
        push eax
          mov msg.hwnd, eax
          mov msg.message, WM_NCPAINT
          mov msg.wParam, 0 // update region
          mov msg.lParam, 0
          push offset msg
          call dispatchmsg
        pop eax
        // paint
        mov msg.hwnd, eax
        mov msg.message, WM_PAINT
        mov msg.wParam, 0
        mov msg.lParam, 0
        push offset msg
        call dispatchmsg
       pop esi
      pop edx
      
    l_defsetwinpos_28:
  pop eax

l_defsetwinpos_3:
test eax, SWP_RELMOVE
jz near l_defsetwinpos_39
  // relative move
  push edx
   push esi
     mov edi, offset win1
     call getwin
   pop esi
   movsx ecx, win1.x
   movsx ebx, win1.y
   add [esi + offset WindowPosRec.x], ecx
   add [esi + offset WindowPosRec.y], ebx
   jmp l_defsetwinpos_33
   
l_defsetwinpos_39:
test eax, SWP_NOMOVE
jnz l_defsetwinpos_8
  // move
  push edx
   push esi
     mov edi, offset win1
     call getwin
   pop esi
   
   l_defsetwinpos_33:
   push esi
     // wm_move
     mov eax, win1.hwnd
     mov msg.hwnd, eax
     mov msg.message, WM_MOVE
     mov msg.wParam, 0
     mov msg.lParam, esi
     push offset msg
     call dispatchmsg
   pop esi
  pop edx
  push edx
   push esi
     mov edi, offset win1
     call getwin
   pop esi
   push esi
    mov ecx, [esi + offset WindowPosRec.x]
    mov ebx, [esi + offset WindowPosRec.y]
    mov ah, 100 // wmove
    int 20h
   pop esi
  pop edx
  test al, al
  jnz l_defsetwinpos_38
    call checkregion
    mov edi, offset win1
    push edx
     push esi
      call getwin
     pop esi
    pop edx
    call checkregion
    
  l_defsetwinpos_38:
  
l_defsetwinpos_8:
movsx ecx, word ptr [ebp - 8]
movsx ebx, word ptr [ebp - 6]
movsx esi, word ptr [ebp - 4]
movsx edi, word ptr [ebp - 2]
cmp ecx, esi
jnl l_defsetwinpos_9
  mov ah, 88  // repaint
  int 20h
  
l_defsetwinpos_9:
mov esp, ebp
pop ebp
ret

// IN: edi = hwnd, ecx = wm, edx = wp, esi = lp
defncpaint:
mov edx, edi
mov ah, 96  // ncpaint
int 20h
ret

defactivate:
test dl, 2 // !!!  1(alt+tab) || 2(click) || 4(other window closed)
jnz near l_defactivate_9
  
  defactivateover:
  mov edx, edi
  push edi
    mov ah, 96 // paint caption
    int 20h
  pop edx
  mov dl, byte ptr [edx + offset WindowExRec.winid]
  cmp dl, MAX_WIN
  jnb l_defactivate_9
    // getwin
    mov edi, offset win1
    mov ah, 98  // get win
    int 20h
    test al, al
    jnz l_defactivate_9
      // repaint win
      movsx ecx, win1.x
      movsx ebx, win1.y
      movsx esi, win1.w
      add esi, ecx
      dec esi
      movsx edi, win1.h
      add edi, ebx
      dec edi
      mov ah, 88  // repaint
      int 20h
      
l_defactivate_9:
ret

defmouseover:
jmp defactivateover
//ret

// IN: edi = hwnd, esi = pressed_mask
defpaintbuttons:
test edi, edi
jz l_defpaintbuttons_9
  mov ecx, esi
  mov dl, [edi + offset WindowExRec.winid]
  push edi
    call setbuttons
  pop edi
  
  push edi
    xor eax, eax
    mov msg.hwnd, edi
    mov msg.message, WM_NCPAINT
    mov msg.wParam, eax  //... update rect?
    mov msg.lParam, eax
    push offset msg
    call dispatchmsg
  pop edi
  
  mov dl, [edi + offset WindowExRec.winid]
  mov edi, offset win1
  call getwin
  
  movsx ecx, win1.x
  movsx ebx, win1.y
  movsx esi, win1.w
  add esi, ecx
  mov ecx, esi
  sub ecx, WIN_HEADER * 3 + WIN_BORDER
  mov edi, ebx
  add edi, WIN_HEADER + WIN_BORDER        
  call repaint
  
l_defpaintbuttons_9:
ret

// IN: edi = hwnd
defclose:
//push 0
//call postquit
push edi
call destroywin
ret

wmpaint:
//... children
ret

// IN: edi = hwnd, edx = SW_*
wmshow:
push ebp
mov ebp, esp
  sub esp, 2 * 4 + sizeof MessageRec
  
  mov word ptr [ebp - 8], 32767
  mov word ptr [ebp - 6], 32767
  mov word ptr [ebp - 4], -1
  mov word ptr [ebp - 2], -1
  
  mov eax, edx
  
  cmp al, SW_HIDE
  jnz l_showwindow_11
    mov al, SW_MINIMIZE
    
  l_showwindow_11:
  cmp al, SW_SHOW
  jnz l_showwindow_12
    mov al, SW_RESTORE
    
  l_showwindow_12:
  test edi, edi
  jz near l_showwindow_9
    push eax
      push edi
        mov dl, [edi + offset WindowExRec.winid]
        mov edi, offset win1
        call getwin
      pop edi
      call checkregion
    pop eax
    
    mov dl, [edi + offset WindowExRec.winid]
    mov dh, al
    mov ah, 109 // show window
    push edi
      int 20h
    pop edi
    
    // send wm_size
    mov [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.hwnd], edi
    mov dword ptr [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.message], WM_SIZE
    mov dword ptr [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.wParam], 0
    mov eax, [edi + offset WindowExRec.w]  // :KLUDGE:
    mov [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.lParam], eax
    mov eax, ebp
    sub eax, 8 + sizeof MessageRec
    push edi
      push eax
      call dispatchmsg
    pop edi
    // send ncpaint
    mov [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.hwnd], edi
    mov dword ptr [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.message], WM_NCPAINT
    mov dword ptr [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.wParam], 0
    mov dword ptr [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.lParam], 0
    mov eax, ebp
    sub eax, 8 + sizeof MessageRec
    push edi
      push eax
      call dispatchmsg
    pop edi
    // send paint
    mov [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.hwnd], edi
    mov dword ptr [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.message], WM_PAINT
    mov dword ptr [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.wParam], 0
    mov dword ptr [ss:ebp - 8 - sizeof MessageRec + offset MessageRec.lParam], 0
    mov eax, ebp
    sub eax, 8 + sizeof MessageRec
    push edi
      push eax
      call dispatchmsg
    pop edi
    
    mov dl, [edi + offset WindowExRec.winid]
    mov edi, offset win1
    call getwin
    call checkregion
    
    // repaint?
    movsx ecx, word ptr [ebp - 8]
    movsx ebx, word ptr [ebp - 6]
    movsx esi, word ptr [ebp - 4]
    movsx edi, word ptr [ebp - 2]
    cmp ecx, esi
    jnl l_showwindow_9
      mov ah, 88  // repaint
      int 20h
        
  l_showwindow_9:
  mov eax, 1
  
mov esp, ebp
pop ebp
ret

main:
mov first_cache, 0

//...

ret

import:

import_table:
dd offset gdi32_lookup + CRVA
dd 0 // dtm_stamp
dd 0 // forwarder_chain
dd offset gdi32_name + CRVA // user32_name_rva
dd offset gdi32_lookup + CRVA // import_adr_table_rva

//...

dd 0,0,0,0,0


gdi32_name: db "gdi32.dll\0"

gdi32_lookup:
ibitblt: dd offset mbitblt + CRVA // bit 31 must be 0
icreatecompatibledc: dd offset mcreatecompatibledc + CRVA // bit 31 must be 0
ideleteobject: dd offset mdeleteobject + CRVA // bit 31 must be 0
iselectobject: dd offset mselectobject + CRVA // bit 31 must be 0
//...
dd 0

mbitblt:
dw 0 // hint
db "BitBlt\0"
[fill 2]

mcreatecompatibledc:
dw 0 // hint
db "CreateCompatibleDC\0"
[fill 2]

mdeleteobject:
dw 0 // hint
db "DeleteObject\0"
[fill 2]

mselectobject:
dw 0 // hint
db "SelectObject\0"
[fill 2]

//...

import_lastoffset:

img_enter:
push eax
  
  l_img_enter_1:
  mov al, 1
  lock xchg al, img_busy
  test al, al
  jz l_img_enter_9
    call noop
    jmp short l_img_enter_1
    
  l_img_enter_9:
pop eax
ret

img_leave:
mov img_busy, 0
ret

// IN: edi -> HIMAGE (HBITMAP, HCURSOR, HICON), img_doflip
flipimg:
test img_doflip, 1
jz l_flipimg_9
test edi, edi
jz l_flipimg_9
 push edi
  movzx ecx, word ptr [edi]  // w
  jecxz l_flipimg_94
    movzx ebx, word ptr [edi + 4]  // h
    test ebx, ebx
    jz l_flipimg_94
      add edi, 8
      mov esi, edi
      mov eax, ecx
      dec ebx
      mul ebx
      shl eax, 2
      add esi, eax  // esi += w * (h - 1) * 4
      
      l_flipimg_5:
        cmp esi, edi
        jng l_flipimg_94
          push esi
           push ecx
           
            l_flipimg_55:
              mov eax, [esi]
              mov edx, [edi]
              mov [esi], edx
              mov [edi], eax
              add esi, 4
              add edi, 4
              loop l_flipimg_55
              
           pop ecx
          pop esi
          mov eax, ecx
          shl eax, 2
          sub esi, eax
          jmp short l_flipimg_5
      
  l_flipimg_94:
 pop edi
 
l_flipimg_9:
ret

// IN: ebx -> filehandle, img_id
// OUT: al = erc, edi -> new block || 0, img_doflip
// KEEP: ebx
loadimg:
push ebx
  mov edi, offset bmp_info_header
  mov ecx, sizeof BitmapInfoHeader
  // IN: ebx = fhandle, edi -> data, ecx = size
  // OUT: al = erc, ecx = size read
  call fread
pop ebx
test al, al
jnz near l_loadimg_9

// flip?
mov img_doflip, 1
cmp bmp_info_header.h, 0
jnl l_loadimg_1
  mov img_doflip, 0
  neg bmp_info_header.h
  
l_loadimg_1:
// check size
mov eax, bmp_info_header.w
mul bmp_info_header.h
test edx, edx
jz l_loadimg_12
  mov al, ERC_INVALID_IMAGE
  jmp l_loadimg_9
  
l_loadimg_12:
cmp eax, 16384 * 16384
jna l_loadimg_13
  mov al, ERC_INVALID_IMAGE
  jmp l_loadimg_9

l_loadimg_13:
cmp eax, 0
jnz l_loadimg_14
  mov al, ERC_INVALID_IMAGE
  jmp l_loadimg_9

l_loadimg_14:
push ebx
  shl eax, 2  // * 4
  add eax, 8  // w, h
  xchg ecx, eax
  push ecx
    call malloc
  pop ecx
  mov edi, ebx
pop ebx
test edi, edi
jz near l_loadimg_9

mov eax, bmp_info_header.w
mov edx, bmp_info_header.h
mov [edi + 0], eax
mov [edi + 4], edx

mov al, byte ptr bmp_info_header.bpp
cmp al, 32
jnz l_loadimg_2
  // 32 bit
  push edi
   push ebx
    add edi, 8
    sub ecx, 8
    call fread
   pop ebx
  pop edi
  jmp l_loadimg_91
  
l_loadimg_2:
cmp al, 24
jnz near l_loadimg_3
  // 24 bit, IN: edx
  push edi
    push ebx
      mov eax, bmp_info_header.w
      mov ecx, eax
      shl eax, 2
      add eax, ecx
      add eax, 3
      shr eax, 2
      shl eax, 2
      mul edx
      xchg ecx, eax
      push ecx
        call malloc
      pop ecx
      mov esi, ebx
    pop ebx
  pop edi
  test al, al
  jnz near l_loadimg_91
  push edi
    push ebx
      push ecx
       push esi
        mov edi, esi
        call fread
       pop esi
      pop ecx
    pop ebx
  pop edi
  test al, al
  jnz near l_loadimg_90
  push ebx
    push edi
     push esi
      add edi, 8
      mov ecx, bmp_info_header.h
      cmp img_id, IMG_ID_BITMAP
      jz l_loadimg_21
        shr ecx, 1
        
      l_loadimg_21:
      jecxz l_loadimg_28
        cld
        
        l_loadimg_24:
        push ecx
          mov ecx, bmp_info_header.w
          
          l_loadimg_25:
            lodsb
            ror eax, 8
            lodsb
            ror eax, 8
            lodsb
            ror eax, 16
            or eax, 0xFF000000
            stosd
            loop l_loadimg_25
            
        pop ecx
        add esi, 3
        and esi, -4
        loop l_loadimg_24
      
      cmp img_id, IMG_ID_BITMAP
      jz l_loadimg_28
        mov eax, bmp_info_header.w
        mul bmp_info_header.h
        mov ecx, 3
        mul ecx
        shr eax, 1
        xchg ecx, eax
        rep movsb
        
      l_loadimg_28:
     pop ebx
     call free
    pop edi
  pop ebx
  xor eax, eax
  jmp l_loadimg_9
  
l_loadimg_3:  // al = bpp
cmp al, 4
jnz near l_loadimg_4
  // 4 bit - 16 colors, IN: edx
  mov ecx, bmp_info_header.palette
  shl ecx, 2  // * 4
  test ecx, ecx
  jnz l_loadimg_31
    mov ecx, 16 * 4
    
  l_loadimg_31:
  mov img_colors, ecx
  push edi
    push ebx
      mov eax, bmp_info_header.w
      add eax, 7
      shr eax, 3
      shl eax, 2
      mul edx
      add ecx, eax
      push ecx
        call malloc
      pop ecx
      mov esi, ebx
    pop ebx
  pop edi
  test al, al
  jnz near l_loadimg_91
  push edi
    push ebx
      push ecx
       push esi
        mov edi, esi
        call fread
       pop esi
      pop ecx
    pop ebx
  pop edi
  test al, al
  jnz near l_loadimg_90
  
  push ebx
   push edi
    mov ebx, esi
    add edi, 8
    add esi, img_colors
    cld
      
    mov ecx, bmp_info_header.h
    cmp img_id, IMG_ID_BITMAP
    jz l_loadimg_32
      shr ecx, 1
    
    l_loadimg_32:
    jecxz l_loadimg_38
    
    l_loadimg_33:
      push ecx
        mov ecx, bmp_info_header.w
        inc ecx
        shr ecx, 1
        
        l_loadimg_35:
          lodsb
          mov edx, eax
          shr eax, 4
          and eax, 15
          mov eax, [ebx + eax * 4]
          or eax, 0xFF000000
          stosd
          xchg eax, edx
          and eax, 15
          mov eax, [ebx + eax * 4]
          or eax, 0xFF000000
          stosd
          loop l_loadimg_35
        
      pop ecx
      add esi, 3
      and esi, -4
      loop l_loadimg_33
      
    cmp img_id, IMG_ID_BITMAP
    jz l_loadimg_38
      mov eax, bmp_info_header.w
      mul bmp_info_header.h
      shr eax, 2
      xchg ecx, eax
      rep movsb
      
    l_loadimg_38:
    call free  // in: ebx
   pop edi
  pop ebx
  xor eax, eax
  jmp l_loadimg_9
  
l_loadimg_4:  // al = bpp
cmp al, 1
jnz near l_loadimg_5
  // 1 bit - 2 colors, IN: edx
  mov ecx, bmp_info_header.palette
  shl ecx, 2  // * 4
  test ecx, ecx
  jnz l_loadimg_41
    mov ecx, 2 * 4
    
  l_loadimg_41:
  mov img_colors, ecx
  push edi
    push ebx
      mov eax, bmp_info_header.w
      add eax, 31
      shr eax, 5
      shl eax, 2
      mul edx
      add ecx, eax
      push ecx
        call malloc
      pop ecx
      mov esi, ebx
    pop ebx
  pop edi
  test al, al
  jnz near l_loadimg_91
  push edi
    push ebx
      push ecx
       push esi
        mov edi, esi
        call fread
       pop esi
      pop ecx
    pop ebx
  pop edi
  test al, al
  jnz near l_loadimg_90
  
  push ebx
   push edi
    mov ebx, esi
    add edi, 8
    add esi, img_colors
    cld
    mov ecx, bmp_info_header.h
    cmp img_id, IMG_ID_BITMAP
    jz l_loadimg_42
      shr ecx, 1
      
    l_loadimg_42:
    test ecx, ecx
    jz near l_loadimg_48
    
    l_loadimg_43:
      push ecx
        mov ecx, bmp_info_header.w
        mov edx, ecx
        add ecx, 31
        shr ecx, 5
        and edx, 31
        test edx, edx
        jnz l_loadimg_44
          mov dl, 32
        
        l_loadimg_44:
         jecxz l_loadimg_48
          lodsd  // out eax
          push ecx
           push edx
            cmp ecx, 1
            jnz l_loadimg_442
              mov img_i, dl
              jmp short l_loadimg_443
              
            l_loadimg_442:
            mov img_i, 32
            
            l_loadimg_443:
            mov ecx, 32
            xchg edx, eax
            
            l_loadimg_45:
             jecxz l_loadimg_458
              dec ecx
              test dl, 80h
              jnz l_loadimg_452
                mov eax, [ebx]
                jmp short l_loadimg_453
                
              l_loadimg_452:
              mov eax, [ebx + 4]
              
              l_loadimg_453:
              or eax, 0xFF000000
              stosd
              shl dl, 1
              
              test cl, 7
              jnz l_loadimg_456
                shr edx, 8
                
              l_loadimg_456:
              dec img_i
              cmp img_i, 0
              jnz l_loadimg_45
             
             l_loadimg_458:
           pop edx
          pop ecx
          loop l_loadimg_44
          
      pop ecx
      loop l_loadimg_43
      
    cmp img_id, IMG_ID_BITMAP
    jz l_loadimg_48
      mov eax, bmp_info_header.w
      add eax, 31
      shr eax, 5
      mul bmp_info_header.h
      shr eax, 1
      xchg ecx, eax
      rep movsd
      
    l_loadimg_48:
    call free  // in: ebx
   pop edi
  pop ebx
  xor eax, eax
  jmp l_loadimg_9
  
l_loadimg_5:
cmp al, 8
jnz near l_loadimg_6
  // 8 bit - 256 colors, IN: edx
  mov ecx, bmp_info_header.palette
  shl ecx, 2  // * 4
  test ecx, ecx
  jnz l_loadimg_51
    mov ecx, 256 * 4
    
  l_loadimg_51:
  mov img_colors, ecx
  push edi
    push ebx
      mov eax, bmp_info_header.w
      add eax, 3
      shr eax, 2
      shl eax, 2
      mul edx
      add ecx, eax
      push ecx
        call malloc
      pop ecx
      mov esi, ebx
    pop ebx
  pop edi
  test al, al
  jnz near l_loadimg_91
  push edi
    push ebx
      push ecx
       push esi
        mov edi, esi
        call fread
       pop esi
      pop ecx
    pop ebx
  pop edi
  test al, al
  jnz near l_loadimg_90
  
  push ebx
   push edi
    mov ebx, esi
    add edi, 8
    add esi, img_colors
    cld
    mov ecx, bmp_info_header.h
    cmp img_id, IMG_ID_BITMAP
    jz l_loadimg_52
      shr ecx, 1
      
    l_loadimg_52:
    test ecx, ecx
    jz l_loadimg_58
    
    l_loadimg_54:
      push ecx
        mov ecx, bmp_info_header.w
        
        l_loadimg_55:
          lodsb
          movzx eax, al
          mov eax, [ebx + eax * 4]
          or eax, 0xFF000000
          stosd
          loop l_loadimg_55
          
      pop ecx
      add esi, 3
      and esi, -4
      loop l_loadimg_54
        
    cmp img_id, IMG_ID_BITMAP
    jz l_loadimg_58
      mov eax, bmp_info_header.w
      add eax, 3
      shr eax, 2
      mul bmp_info_header.h
      shr eax, 1
      xchg ecx, eax
      rep movsd
      
    l_loadimg_58:
    call free  // in: ebx
   pop edi
  pop ebx
  xor eax, eax
  jmp l_loadimg_9

l_loadimg_6:
mov al, ERC_INVALID_IMAGE
jmp l_loadimg_91

l_loadimg_90:
push eax
 push ebx
  push edi
    mov ebx, esi
    call free
  pop edi
 pop ebx
pop eax

l_loadimg_91:  // free if error
test al, al
jz l_loadimg_9
  push eax
   push ebx
    mov ebx, edi
    call free
   pop ebx
  pop eax
  xor edi, edi
  
l_loadimg_9:
ret

// IN: hwnd, lppaintstruct
// OUT: eax = hdc
beginpaint:
push dword ptr [esp + 4]
call getdc
test eax, eax
jz l_beginpaint_9
  mov edx, [esp + 8]
  mov [eax + offset DCRec.lppaintstruct], edx
  test edx, edx
  jz l_beginpaint_9
    mov [edx], eax  // paintstruct.hdc = hdc
  
l_beginpaint_9:
ret 8

// IN: hdc, x, y, hicon
drawicon:
push ebp
  mov ebp, esp
  sub esp, 4
  
  mov ecx, [ebp + 20]
  jecxz __9
    // create compatible dc
    push [ebp + 8]  // hdc
    call [icreatecompatibledc + COFS]
    mov [ebp - 4], eax  // hdcicon
    // select bitmap
    push [ebp + 20] // hicon
    push [ebp - 4]  // hdcicon
    call [iselectobject + COFS]
    // bitblt
    push SRCMERGE
    push 0 // y1
    push 0 // x1
    push [ebp - 4]  // hdcicon
    
    mov edx, [ebp + 20]  // hicon
    movzx eax, word ptr [edx + 4]
    push eax
    movzx ecx, word ptr [edx + 0]
    push ecx
    
    push [ebp + 16] // y
    push [ebp + 12] // x
    push [ebp + 8]  // hdc
    call [ibitblt + COFS]
    // delete dc
    push [ebp - 4]  // hdcicon
    call [ideleteobject + COFS]
    
  __9:
  xor eax, eax
  
  mov esp, ebp
pop ebp
ret 4 * 4

// IN: hdc, x, y, hicon, cx, cy, istepifanicur, hbrflickerfree, diflags
drawiconex:
//...
ret 9 * 4

// IN: hwnd, lppaintstruct
endpaint:
mov edx, [esp + 8]
test edx, edx
jz l_endpaint_9
  mov ebx, [edx]  // ebx = hdc
  call free
  
l_endpaint_9:
ret 8

// IN: hwnd
// OUT: eax = hdc
getdc:
mov ecx, sizeof DCRec
call malloc
mov edi, ebx
xor eax, eax
mov ecx, sizeof DCRec / 4
cld
rep stosd

mov esi, [esp + 4]  // hwnd
mov dl, [esi + offset WindowExRec.winid]
xor eax, eax
cmp dl, MAX_WIN
jnb l_getdc_9
  mov edi, offset win1
  push ebx
    call getwin
    call getclient
  pop eax
  
  mov [eax + offset DCRec.x0], cx
  mov [eax + offset DCRec.y0], bx
  mov [eax + offset DCRec.x1], cx
  mov [eax + offset DCRec.y1], bx
  mov [eax + offset DCRec.x2], si
  mov [eax + offset DCRec.y2], di
  
  call getdc_def
  
  mov edx, win1.pbitmap
  mov [eax + offset DCRec.pbitmap], edx
  
l_getdc_9:
ret 4


// !!! see also gdi32
getdc_def:
mov dword ptr [eax + offset DCRec.pen], offset defpen + COFS
mov dword ptr [eax + offset DCRec.brush], offset defbrush + COFS
mov dword ptr [eax + offset DCRec.rgn], offset defrgn + COFS
ret

defpen: dd GDIOBJ_PEN, 0xFF000000, 1
defbrush: dd GDIOBJ_BRUSH, 1, 0xFFFFFFFF, 0, 0, 0, 0
defrgn: dd GDIOBJ_RGN, 1, 0, 32767 << 16 + 32767

// IN: hwnd, hdc
releasedc:
mov ebx, [esp + 8]
call free
ret 8

// IN: hwnd, hrgn, flags_dcx
// OUT: eax = hdc
getdcex:
push dword ptr [esp + 4]
call getdc
test eax, eax
jz l_getdcex_9
  mov edx, [esp + 8]
  mov [eax + offset DCRec.rgn], edx
  
l_getdcex_9:
ret 0Ch

// IN: hwnd
getwindowdc:
mov ecx, sizeof DCRec
call malloc
mov edi, ebx
xor eax, eax
mov ecx, sizeof DCRec / 4
cld
rep stosd

mov edx, [esp + 4]  // hwnd
mov dl, [edx + offset WindowExRec.winid]
xor eax, eax
cmp dl, MAX_WIN
jnb l_getwindowdc_9
  mov edi, offset win1
  push ebx
    call getwin
  pop eax
  
  xor ecx, ecx
  mov [eax + offset DCRec.x0], cx
  mov [eax + offset DCRec.y0], cx
  mov [eax + offset DCRec.x1], cx
  mov [eax + offset DCRec.y1], cx
  mov dx, win1.w
  dec edx
  mov [eax + offset DCRec.x2], dx
  mov dx, win1.h
  dec edx
  mov [eax + offset DCRec.y2], dx
  
  call getdc_def
  
  mov edx, win1.pbitmap
  mov [eax + offset DCRec.pbitmap], edx
  
l_getwindowdc_9:
ret 4

// IN: hwnd, lprect
getclientrect:
mov edi, [esp + 4]
test edi, edi
jz l_getclientrect_6
  mov dl, [edi + offset WindowExRec.winid]
  mov edi, offset win1
  call getwin
  test al, al
  jnz l_getclientrect_6
    call getclient
    sub esi, ecx
    sub edi, ebx
    mov edx, [esp + 8]
    xor eax, eax
    mov [edx + 0], eax
    mov [edx + 4], eax
    mov [edx + 8], esi
    mov [edx + 12], edi
    mov eax, 1
    jmp short l_getclientrect_8
    
l_getclientrect_6:
xor eax, eax

l_getclientrect_8:
ret 8

// hwnd, lprect, berase
getupdaterect:
mov edi, [esp + 8]
movsx eax, ux1
mov [edi + 0], eax
movsx eax, uy1
mov [edi + 4], eax
movsx eax, ux2
mov [edi + 8], eax
movsx eax, uy2
mov [edi + 12], eax
ret 0Ch

// IN: hwnd, lprect, bool_erasebk
invalidaterect:
ret 0Ch

// IN: hwnd
updatewindow:
mov edi, [esp + 4]
xor eax, eax
push eax
push eax
push eax
push edi
call redrawwindow
ret 4

// IN: hwnd, lprc_update, hrgn_update, flags_rdw
redrawwindow:
push ebp
mov ebp, esp
sub esp, sizeof MessageRec + 4

push dword ptr ux1  // :KLUDGE: ux1, uy1
push dword ptr ux2  // :KLUDGE: ux2, uy2
  
  mov esi, [ebp + 8]  // hwnd
  mov dl, [esi + offset WindowExRec.winid]
  mov edi, offset win1
  call getwin
  test al, al
  jnz near l_redrawwindow_9
  
  mov edx, [ebp + 16]  // hrgn_update
  test edx, edx
  jz l_redrawwindow_2
    // rgn
    mov ax, [edx + offset RgnRec.left]
    mov ux1, ax
    mov ax, [edx + offset RgnRec.top]
    mov uy1, ax
    mov ax, [edx + offset RgnRec.right]
    mov ux2, ax
    mov ax, [edx + offset RgnRec.bottom]
    mov uy2, ax
    jmp short l_redrawwindow_4
    
  l_redrawwindow_2:
  mov edx, [ebp + 12]  // lprc_update
  test edx, edx
  jz l_redrawwindow_3
    // rect
    mov ax, [edx + offset RectRec.left]
    mov ux1, ax
    mov ax, [edx + offset RectRec.top]
    mov uy1, ax
    mov ax, [edx + offset RectRec.right]
    mov ux2, ax
    mov ax, [edx + offset RectRec.bottom]
    mov uy2, ax
    jmp short l_redrawwindow_4
    
  l_redrawwindow_3:
    // whole client area
    call getclient
    xor eax, eax
    mov ux1, ax
    mov uy1, ax
    mov ax, si
    sub ax, cx
    mov ux2, ax
    mov ax, di
    sub ax, bx
    mov uy2, ax
    
  l_redrawwindow_4:
  mov byte ptr [ebp - sizeof MessageRec - 4], 0
  mov eax, [ebp + 20]  // flags
  test eax, RDW_FRAME
  jz l_redrawwindow_5
    mov byte ptr [ebp - sizeof MessageRec - 4], 1
    // ncpaint
    mov ebx, [ebp + 8]  // hwnd
    mov [ss:ebp - sizeof MessageRec + offset MessageRec.hwnd], ebx
    mov dword ptr [ss:ebp - sizeof MessageRec + offset MessageRec.message], WM_NCPAINT
    mov dword ptr [ss:ebp - sizeof MessageRec + offset MessageRec.wParam], 0
    mov dword ptr [ss:ebp - sizeof MessageRec + offset MessageRec.lParam], 0
    mov eax, ebp
    sub eax, sizeof MessageRec
    push eax
    call dispatchmsg
    
  l_redrawwindow_5:
  // paint
  mov ebx, [ebp + 8]  // hwnd
  mov [ss:ebp - sizeof MessageRec + offset MessageRec.hwnd], ebx
  mov dword ptr [ss:ebp - sizeof MessageRec + offset MessageRec.message], WM_PAINT
  mov dword ptr [ss:ebp - sizeof MessageRec + offset MessageRec.wParam], 0
  mov dword ptr [ss:ebp - sizeof MessageRec + offset MessageRec.lParam], 0
  mov eax, ebp
  sub eax, sizeof MessageRec
  push eax
  call dispatchmsg
  
  // get win
  mov esi, [ebp + 8]  // hwnd
  mov dl, [esi + offset WindowExRec.winid]
  mov edi, offset win1
  call getwin
  test al, al
  jnz near l_redrawwindow_9
    test byte ptr [ebp - sizeof MessageRec - 4], 1
    jz l_redrawwindow_6
      // paint whole window
      movsx ecx, win1.x
      movsx ebx, win1.y
      movsx esi, win1.w
      add esi, ecx
      dec esi
      movsx edi, win1.h
      add edi, ebx
      dec edi
      call repaint
      jmp short l_redrawwindow_9
    
    l_redrawwindow_6:
      // paint only update rect
      call getclient
      movsx edx, win1.x      
      movsx eax, ux2
      add eax, ecx
      cmp eax, esi
      jng l_redrawwindow_61
        mov eax, esi
        
      l_redrawwindow_61:
      add eax, edx
      mov esi, eax
      
      movsx eax, ux1
      add ecx, eax
      add ecx, edx
      
      movsx edx, win1.y
      movsx eax, uy2
      add eax, ebx
      cmp eax, edi
      jng l_redrawwindow_62
        mov eax, edi
        
      l_redrawwindow_62:
      add eax, edx
      mov edi, eax
      
      movsx eax, uy1
      add ebx, eax
      add ebx, edx
      
      call repaint
      
l_redrawwindow_9:
pop dword ptr ux2  // :KLUDGE: ux2, uy2
pop dword ptr ux1  // :KLUDGE: ux1, uy1

mov esp, ebp
pop ebp
ret 10h

// IN: hInst, pnamez
loadbitmap:
call img_enter

mov img_id, IMG_ID_BITMAP

mov edx, [esp + 8]  // pnamez
call fopenread  // in edx
test al, al
jnz l_loadbitmap_94

push ebx
  mov edi, offset bmp_fheader
  mov ecx, sizeof BitmapFileHeader
  call fread
pop ebx
test al, al
jnz l_loadbitmap_93

push ebx
  call loadimg  // out edi
pop ebx
test al, al
jnz l_loadbitmap_93

push edi
  call fclose
pop edi

// IN: edi -> HIMAGE (HBITMAP, HCURSOR, HICON)
call flipimg

mov eax, edi
call img_leave
ret 8

l_loadbitmap_93:
push eax
  call fclose
pop eax

l_loadbitmap_94:
mov lasterror, al
xor eax, eax
call img_leave
ret 8

loadcursor:
call img_enter

mov img_id, IMG_ID_CURSOR
jmp short loadcommon
//ret 8

// IN: hInstance, lpIconName
// OUT: hIcon
loadicon:
call img_enter
mov img_id, IMG_ID_ICON

loadcommon:
mov lasterror, 0
mov ebx, [esp + 4]  // hInstance
mov edx, [esp + 8]  // lpIconName
cmp edx, 4096  // MAKEINTRESOURCE
jb near l_loadi_res
  // search in cache by file name
  mov esi, edx
  call strlen  // keep esi, ebx
  inc ecx
  cmp ecx, MAX_PATH
  jna l_loadi_1
    mov ecx, MAX_PATH
    
  l_loadi_1:
  mov edi, first_cache
  
  l_loadi_25:
  cmp edi, 0
  jz l_loadi_4
    cmp ebx, [edi + offset ImageCache.hinst]
    jnz l_loadi_28
    
    push ecx
     push edi
      push esi
       push ebx
        add edi, offset ImageCache.name
        // IN: esi -> str1, edi -> str2, ecx = count
        // OUT: al = 0(eq) || 1
        call strcmp
       pop ebx
      pop esi
     pop edi
    pop ecx
    test al, al
    jz l_loadi_3
      
      l_loadi_28:
      mov edi, [edi + offset ImageCache.next]
      jmp l_loadi_25
      
    l_loadi_3:
    mov eax, [edi + offset ImageCache.ptr]
    jmp l_loadi_9
    
  l_loadi_4:
  // load from file
  mov edx, esi
  call fopenread  // in edx
  test al, al
  jnz near l_loadi_81
  push ebx
    mov edi, offset icon_dir
    mov ecx, sizeof IconDir
    call fread  // in ebx
  pop ebx
  test al, al
  jnz near l_loadi_8
  push ebx
    mov edi, offset icon_dir_entry
    mov ecx, sizeof IconDirEntry
    call fread
  pop ebx
  test al, al
  jnz near l_loadi_8
  push ebx
    xor edx, edx
    mov edi, icon_dir_entry.ofs
    // IN: ebx = fhandle, edx:edi = file offset
    // OUT: al = erc
    call fsetpos
  pop ebx
  test al, al
  jnz near l_loadi_8
  push ebx
    call loadimg  // out edi
  pop ebx
  test al, al
  jnz near l_loadi_8
  
  push ebx
   push edi
    movzx eax, icon_dir_entry.w
    test eax, eax
    jnz l_loadi_41
      mov ah, 1
      
    l_loadi_41:
    movzx ecx, icon_dir_entry.h
    test ecx, ecx
    jnz l_loadi_42
      mov ch, 1
      
    l_loadi_42:
    mov img_w, eax
    mov img_h, ecx
    mul ecx
    shl eax, 2  // * 4
    add eax, 8
    xchg ecx, eax
    push ecx
      // IN: ecx = size
      // OUT: al = erc, ebx = ptr
      call malloc
    pop ecx  // ecx = w * h * 4 + 8
    mov edi, ebx
   pop esi  // esi = loadimg
  pop ebx
  test al, al
  jnz near l_loadi_7
  
  push ebx
   push esi
    push edi
     sub ecx, 8
     shr ecx, 2
     cld
     
     mov eax, img_w
     stosd
     mov eax, img_h
     stosd
     shl eax, 1
     cmp ax, [esi + 4]
     jz l_loadi_46  // img_h * 2 == loadimg.h
       
       add esi, 8
       rep movsd
       jmp short l_loadi_48
       
     l_loadi_46:
     add esi, 8
     rep movsd
     
    pop edi
    push edi
     add edi, 8
     
     // transparency [edi][esi]
     movzx ecx, word ptr img_h
     jecxz l_loadi_48
     
     l_loadi_471:
     lodsd
     push ecx
       movzx ecx, word ptr img_w
       
       cmp ecx, 32
       jz l_loadi_474
         cmp ecx, 16
         jnz l_loadi_478
         
       l_loadi_474:  // ecx = 16 || 32
        jecxz l_loadi_478
         test al, 80h
         jz l_loadi_475
           cmp img_id, IMG_ID_BITMAP
           jz l_loadi_4741
             test dword ptr [edi], 0x00FFFFFF
             jz l_loadi_4741
               mov dword ptr [edi], 1  // invert
               jmp short l_loadi_475
               
           l_loadi_4741:
           and dword ptr [edi], 0
           //mov dword ptr [edi], 0FFFF0000h  //$$$
           
         l_loadi_475:
         dec ecx
         test cl, 7
         jnz l_loadi_476
           shr eax, 8
           jmp short l_loadi_477
           
         l_loadi_476:
         shl al, 1
         
         l_loadi_477:
         add edi, 4
         jmp short l_loadi_474
         
       l_loadi_478:  
     pop ecx
     loop l_loadi_471
     
     l_loadi_48:
    pop edi
   pop ebx  // loadimg
   push edi
    call free
   pop edi
  pop ebx
  
  // hotspots of cursor
  cmp img_id, IMG_ID_CURSOR
  jnz l_loadi_50
    mov ax, icon_dir_entry.planes
    mov dx, icon_dir_entry.bpp
    mov word ptr [edi + 2], ax
    mov word ptr [edi + 6], dx
    
  l_loadi_50:
  
  // add to cache
  mov ecx, sizeof ImageCache
  push ebx
   push edi
    call malloc
    mov esi, ebx
   pop edi
  pop ebx
  test al, al
  jnz l_loadi_7
  
  push ebx
    push esi
     push edi
      mov edi, esi
      add edi, offset ImageCache.name
      
      mov esi, [esp + 8 + 12]  // lpIconName
      call strlen
      cmp ecx, MAX_PATH
      jb l_loadi_51
        mov ecx, MAX_PATH - 1
        
      l_loadi_51:
      cld
      rep movsb
      mov al, 0
      stosb
     pop edi 
    pop esi
  pop ebx
  
  mov [esi + offset ImageCache.ptr], edi
  mov ebx, [esp + 4]  // hInstance
  mov [esi + offset ImageCache.hinst], ebx
  mov eax, first_cache
  mov [esi + offset ImageCache.next], eax
  mov first_cache, esi
  
  xor eax, eax
  jmp short l_loadi_8
  
  l_loadi_7:  // free esi, edi
  push ebx
   push eax
    push edi
      mov ebx, esi
      call free
    pop ebx
    call free
    xor esi, esi
    xor edi, edi
   pop eax
  pop ebx
  
  l_loadi_8:  // close ebx
  push eax
   push edi
    call fclose
   pop edi
  pop eax
  test al, al
  jz l_loadi_82
    
    l_loadi_81:
    mov lasterror, al
    xor eax, eax  // return 0
    jmp l_loadi_9
    
  l_loadi_82:
  call flipimg
  mov eax, edi  // return edi
  jmp l_loadi_9
  
l_loadi_res:
// search in cache by INTRESOURCE - IN: edx
mov edi, first_cache

l_loadi_res2:
cmp edi, 0
jz l_loadi_res4
  cmp edx, [edi + offset ImageCache.name]
  jz l_loadi_res3
    mov edi, [edi + offset ImageCache.next]
    jmp short l_loadi_res2
    
  l_loadi_res3:
  mov eax, [edi + offset ImageCache.ptr]
  jmp short l_loadi_9
  
l_loadi_res4:
// load from resources

//...

xor eax, eax

l_loadi_9:
call img_leave
ret 8

// IN: hInst, pnamez, type, x, y, flags
loadimage:

ret 24

setwinpos:
push ebp
mov ebp, esp
  mov ecx, sizeof WindowPosRec
  call gmalloc
  test al, al
  jnz l_setwinpos_9
    // hwnd only of the same process, else 1..MAX_WIN winid
    mov edi, [ebp + 8]  // edi = hwnd
    mov [ebx + offset WindowPosRec.hwnd], edi
    
    mov eax, [ebp + 12]
    mov [ebx + offset WindowPosRec.hwndInsertAfter], eax
    mov eax, [ebp + 16]
    mov [ebx + offset WindowPosRec.x], eax
    mov eax, [ebp + 20]
    mov [ebx + offset WindowPosRec.y], eax
    mov eax, [ebp + 24]
    mov [ebx + offset WindowPosRec.cx], eax
    mov eax, [ebp + 28]
    mov [ebx + offset WindowPosRec.cy], eax
    mov eax, [ebp + 32]
    mov [ebx + offset WindowPosRec.flags], eax
    
    push ebx
      mov esi, ebx
      mov al, ERC_INVALID_WINDOW
      cmp edi, 1
      jb l_setwinpos_8  // null
        cmp edi, MAX_WIN
        ja l_setwinpos_6
          mov ebx, edi  // 1..MAX_WIN
          dec ebx
          jmp short l_setwinpos_7
          
      l_setwinpos_6:
      movzx ebx, byte ptr [edi + offset WindowExRec.winid]  // hwnd
      
      l_setwinpos_7:
      xor edx, edx
      mov ecx, WM_WINDOWPOSCHANGED
      call postmsgwin
      
      l_setwinpos_8:
    pop ebx
    test al, al
    jz l_setwinpos_9
      push eax
        call gfree
        xor ebx, ebx
      pop eax
      
  l_setwinpos_9:
mov esp, ebp
pop ebp
ret 1Ch

// IN: [+8] hwnd || (winid + 1), [+12] SW_*
showwindow:
push ebp
mov ebp, esp
  // hwnd only of the same process, else 1..MAX_WIN winid
  mov edi, [ss:ebp + 8]  // hwnd
  mov al, ERC_INVALID_WINDOW
  cmp edi, 1
  jb l_showwindow_8  // null
    cmp edi, MAX_WIN
    ja l_showwindow_6
      mov ebx, edi  // 1..MAX_WIN
      dec ebx
      jmp short l_showwindow_7
      
  l_showwindow_6:
  movzx ebx, byte ptr [edi + offset WindowExRec.winid]  // hwnd
  
  l_showwindow_7:
  mov ecx, WM_SHOWWINDOW
  mov edx, [ss:ebp + 12] // sw
  xor esi, esi
  call postmsgwin
  
  l_showwindow_8:
mov esp, ebp
pop ebp  
ret 8

// OUT: eax = hwnd
createwin:
push ebp
mov ebp, esp
sub esp, sizeof CreateRec + sizeof MessageRec
  mov lasterror, 0
  // set CreateRec.*
  mov eax, [ss:ebp + 8]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.dwExStyle], eax
  mov eax, [ss:ebp + 12]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.lpszClass], eax
  mov eax, [ss:ebp + 16]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.lpszName], eax
  mov eax, [ss:ebp + 20]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.style], eax
  mov eax, [ss:ebp + 24]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.x], eax
  mov eax, [ss:ebp + 28]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.y], eax
  mov eax, [ss:ebp + 32]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.cx], eax
  mov eax, [ss:ebp + 36]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.cy], eax
  mov eax, [ss:ebp + 40]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.hwndParent], eax
  mov eax, [ss:ebp + 44]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.hMenu], eax
  mov eax, [ss:ebp + 48]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.hInstance], eax
  mov eax, [ss:ebp + 52]
  mov [ss:ebp - sizeof CreateRec + offset CreateRec.lpCreateParams], eax
  // find
  mov edi, regclass
  
  l_createwin_15:
    test edi, edi
    jnz l_createwin_16
      mov al, ERC_UNKNOWN_CLASS
      jmp l_createwin_91
    
    l_createwin_16:
    push edi
      mov edi, [edi + offset WndClassRec.lpszClassName]
      mov esi, [ss:ebp - sizeof CreateRec + offset CreateRec.lpszClass]
      
      l_createwin_165:
        lodsb
        cmp al, [edi]
        jnz l_createwin_168
          cmp al, 0
          jz l_createwin_158
            inc edi
            jmp short l_createwin_165
            
      l_createwin_168:
    pop edi
    mov edi, [edi + offset WndClassRec.next]
    jmp short l_createwin_15
  
  l_createwin_158:
  pop edi
  // alloc, keep edi
  mov ecx, [edi + offset WndClassRec.cbWndExtra]
  add ecx, sizeof WindowExRec
  push edi
   push ecx
    call malloc
   pop ecx
  pop edi
  test al, al
  jnz near l_createwin_91
  
  // zero hwnd
  push edi
    mov edi, ebx
    xor eax, eax
    cld
    rep stosb
  pop edi
  // fill hwnd 1
  mov [ebx + offset WindowExRec.pclass], edi
  mov eax, [edi + offset WndClassRec.lpfnWndProc]
  mov [ebx + offset WindowExRec.wndproc], eax
  mov eax, [ss:ebp - sizeof CreateRec + offset CreateRec.hwndParent]
  mov [ebx + offset WindowExRec.parent], eax
  mov eax, [ss:ebp - sizeof CreateRec + offset CreateRec.style]
  mov [ebx + offset WindowExRec.style], eax
  mov eax, [ss:ebp - sizeof CreateRec + offset CreateRec.dwExStyle]
  mov [ebx + offset WindowExRec.exstyle], eax
  mov eax, [ss:ebp - sizeof CreateRec + offset CreateRec.hMenu]
  mov [ebx + offset WindowExRec.pmenu], eax
  mov eax, [ss:ebp - sizeof CreateRec + offset CreateRec.hInstance]
  mov [ebx + offset WindowExRec.hinstance], eax
  // create win
  test dword ptr [ss:ebp - sizeof CreateRec + offset CreateRec.style], WS_CHILD
  jnz l_createwin_2
    // window
    mov esi, ebx
    mov cx, [ss:ebp - sizeof CreateRec + offset CreateRec.y]
    shl ecx, 16
    mov cx, [ss:ebp - sizeof CreateRec + offset CreateRec.x]
    mov dx, [ss:ebp - sizeof CreateRec + offset CreateRec.cy]
    shl edx, 16
    mov dx, [ss:ebp - sizeof CreateRec + offset CreateRec.cx]
    push ebx
      mov ebx, [ss:ebp - sizeof CreateRec + offset CreateRec.style]
      call create  // out edx
    pop ebx
    test al, al
    jz l_createwin_3
      push eax
        call free
      pop eax
      jmp l_createwin_91
      
  l_createwin_2:  // child window
  mov edx, WIN_NONE
  mov ax, [ss:ebp - sizeof CreateRec + offset CreateRec.x]
  mov [ebx + offset WindowExRec.x], ax
  mov ax, [ss:ebp - sizeof CreateRec + offset CreateRec.y]
  mov [ebx + offset WindowExRec.y], ax
  mov ax, [ss:ebp - sizeof CreateRec + offset CreateRec.cx]
  mov [ebx + offset WindowExRec.w], ax
  mov ax, [ss:ebp - sizeof CreateRec + offset CreateRec.cy]
  mov [ebx + offset WindowExRec.h], ax
  jmp short l_createwin_31
  
  l_createwin_3:
  // fill hwnd 2 - window
  mov edi, offset win1
  push edx
   push ebx
    call getwin
   pop ebx
  pop edx
  mov ax, win1.x
  mov [ebx + offset WindowExRec.x], ax
  mov ax, win1.y
  mov [ebx + offset WindowExRec.y], ax
  mov ax, win1.w
  mov [ebx + offset WindowExRec.w], ax
  mov ax, win1.h
  mov [ebx + offset WindowExRec.h], ax
  
  l_createwin_31:
  // fill hwnd 3 - both
  mov [ebx + offset WindowExRec.winid], edx  // winid
  mov dword ptr [ebx + offset WindowExRec.menusx], 0  // menusx
  
  push ebx
    call getpid
    mov eax, ebx
  pop ebx
  mov [ebx + offset WindowExRec.pid], eax  // pid
  
  // ptext
  mov esi, [ss:ebp - sizeof CreateRec + offset CreateRec.lpszName]
  test esi, esi
  jz l_createwin_33
    call strlen
    jecxz l_createwin_33
      inc ecx
      push ebx
       push esi
        push ecx
          call malloc
          mov edi, ebx
        pop ecx
       pop esi
      pop ebx
      push edi
        cld
        rep movsb
      pop edi
      jmp short l_createwin_34
      
  l_createwin_33:
  xor edi, edi
  
  l_createwin_34:
  mov [ebx + offset WindowExRec.ptext], edi  // ptext
  
  // children
  xor eax, eax
  mov [ebx + offset WindowExRec.next], ebx
  mov [ebx + offset WindowExRec.prev], ebx
  mov [ebx + offset WindowExRec.first_child], eax
  
  mov esi, [ebx + offset WindowExRec.parent]
  test esi, esi
  jz l_createwin_48
    mov edi, [esi + offset WindowExRec.first_child]
    test edi, edi
    jnz l_createwin_46
      mov [esi + offset WindowExRec.first_child], ebx
      jmp short l_createwin_48
      
    l_createwin_46:  // edi = first child
    mov esi, [edi + offset WindowExRec.prev]
    mov [ebx + offset WindowExRec.next], edi
    mov [ebx + offset WindowExRec.prev], esi
    mov [esi + offset WindowExRec.next], ebx
    mov [edi + offset WindowExRec.prev], ebx  // add to parent
    
  l_createwin_48:
  push ebx
    // send wm_create
    mov [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.hwnd], ebx
    mov dword ptr [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.message], WM_CREATE
    mov dword ptr [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.wParam], 0
    mov eax, ebp
    sub eax, sizeof CreateRec
    mov [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.lParam], eax
    mov eax, ebp
    sub eax, sizeof CreateRec + sizeof MessageRec
    push eax
    call dispatchmsg
  pop ebx
  push ebx
    test dword ptr [ss:ebp - sizeof CreateRec + offset CreateRec.style], WS_CHILD
    jnz near l_createwin_58
      // wshow
      mov eax, [ss:ebp - sizeof CreateRec + offset CreateRec.style]
      mov dl, [ebx + offset WindowExRec.winid]
      test eax, WS_MINIMIZE
      jnz l_createwin_55
       test eax, WS_VISIBLE
       jnz l_createwin_56
        
        l_createwin_55:
        // invisible/minimized
        mov dh, SW_MINIMIZE
        call wshow
        jmp l_createwin_58
        
      l_createwin_56:
      test eax, WS_MAXIMIZE
      jz l_createwin_564
        // maximized
        mov dh, SW_MAXIMIZE
        jmp short l_createwin_565
        
      l_createwin_564:
      // restored
      mov dh, SW_RESTORE
      
      l_createwin_565:
      push ebx
        call wshow
      pop ebx
      push ebx
        mov dl, [ebx + offset WindowExRec.winid]
        mov edi, offset win1
        call getwin
      pop ebx
      
      // send wm_size
      mov [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.hwnd], ebx
      mov dword ptr [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.message], WM_SIZE
      mov dword ptr [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.wParam], 0
      mov eax, dword ptr win1.w  // :KLUDGE:
      mov [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.lParam], eax
      mov eax, ebp
      sub eax, sizeof CreateRec + sizeof MessageRec
      push ebx
        push eax
        call dispatchmsg
      pop ebx
      
      // ncpaint
      mov [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.hwnd], ebx
      mov dword ptr [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.message], WM_NCPAINT
      mov dword ptr [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.wParam], 0
      mov dword ptr [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.lParam], 0
      mov eax, ebp
      sub eax, sizeof CreateRec + sizeof MessageRec
      push ebx
        push eax
        call dispatchmsg
      pop ebx
      
      // paint
      mov [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.hwnd], ebx
      mov dword ptr [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.message], WM_PAINT
      mov dword ptr [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.wParam], 0
      mov dword ptr [ss:ebp - sizeof CreateRec - sizeof MessageRec + offset MessageRec.lParam], 0
      mov eax, ebp
      sub eax, sizeof CreateRec + sizeof MessageRec
      push ebx
        push eax
        call dispatchmsg
      pop ebx
      
      // repaint
      mov dl, [ebx + offset WindowExRec.winid]
      mov edi, offset win1
      call getwin
      movsx ecx, win1.x
      movsx ebx, win1.y
      movsx esi, win1.w
      add esi, ecx
      dec esi
      movsx edi, win1.h
      add edi, ebx
      dec edi
      call repaint
      
    l_createwin_58:
  pop eax
  
  l_createwin_9:
mov esp, ebp
pop ebp
ret 30h

l_createwin_91:
mov lasterror, al
xor eax, eax
jmp l_createwin_9

defwinproc:
push ebp
mov ebp, esp
  mov edi, [ss:ebp + 8]  // hwnd
  mov ecx, [ss:ebp + 12] // wm
  mov edx, [ss:ebp + 16] // wp
  mov esi, [ss:ebp + 20] // lp
  
  cmp ecx, WM_WINDOWPOSCHANGED
  jnz l_defwinproc_2
    call defsetwinpos
    jmp short l_defwinproc_9
    
  l_defwinproc_2:
  cmp ecx, WM_NCPAINT
  jnz l_defwinproc_3
    call defncpaint
    jmp short l_defwinproc_9
    
  l_defwinproc_3:
  cmp ecx, WM_ACTIVATE
  jnz l_defwinproc_4
    call defactivate
    jmp short l_defwinproc_9
    
  l_defwinproc_4:
  cmp ecx, WM_NCMOUSEOVER
  jnz l_defwinproc_5
    call defmouseover
    jmp short l_defwinproc_9
    
  l_defwinproc_5:
  cmp ecx, WM_PAINTBUTTONS
  jnz l_defwinproc_6
    call defpaintbuttons
    jmp short l_defwinproc_9
    
  l_defwinproc_6:
  cmp ecx, WM_CLOSE
  jnz l_defwinproc_7
    call defclose
    jmp short l_defwinproc_9
    
  l_defwinproc_7:
  
  //...
  
  l_defwinproc_9:
mov esp, ebp
pop ebp
ret 10h

destroywin:
push ebp
mov ebp, esp
sub esp, sizeof MessageRec

  mov edi, [ss:ebp + 8]  // hwnd
  // send wm_destroy
  mov [ss:ebp - sizeof MessageRec + offset MessageRec.hwnd], edi
  mov dword ptr [ss:ebp - sizeof MessageRec + offset MessageRec.message], WM_DESTROY
  mov dword ptr [ss:ebp - sizeof MessageRec + offset MessageRec.wParam], 0
  mov dword ptr [ss:ebp - sizeof MessageRec + offset MessageRec.lParam], 0
  mov eax, ebp
  sub eax, sizeof MessageRec
  push edi
    push eax
    call dispatchmsg
  pop edi
  // release ptext
  mov ebx, [es:edi + offset WindowExRec.ptext]
  push edi
    call free
  pop edi
  // release from parent
  mov edx, [es:edi + offset WindowExRec.parent]
  test edx, edx
  jz l_destroywin_6
    mov ebx, [es:edi + offset WindowExRec.next]
    cmp ebx, edi
    jz l_destroywin_4
      mov ecx, [es:edi + offset WindowExRec.prev]
      mov [es:ecx + offset WindowExRec.next], ebx
      mov [es:ebx + offset WindowExRec.prev], ecx
      cmp [es:edx + offset WindowExRec.first_child], edi
      jnz l_destroywin_6
        mov [es:edx + offset WindowExRec.first_child], ebx
        jmp short l_destroywin_6
        
    l_destroywin_4:
    xor eax, eax
    mov [es:edx + offset WindowExRec.first_child], eax
    
  l_destroywin_6:
  // do destroy
  movzx edx, byte ptr [es:edi + offset WindowExRec.winid]
  push edi
    call destroy
  pop ebx
  // release
  call free
  
mov esp, ebp
pop ebp
ret 4

dispatchmsg:
push ebp
mov ebp, esp
  mov eax, [ebp + 8]
  mov edi, dword ptr [eax + offset MessageRec.hwnd]
  mov ecx, dword ptr [eax + offset MessageRec.message]
  mov edx, dword ptr [eax + offset MessageRec.wParam]
  mov esi, dword ptr [eax + offset MessageRec.lParam]
  
  push esi
  push edx
  push ecx
  push edi
    
    push esi
    push edx
    push ecx
    push edi
    
    test edi, edi
    jz l_dispatchmsg_8
      mov eax, [edi + offset WindowExRec.wndproc]
      test eax, eax
      jz l_dispatchmsg_8
        // call
        call eax
        jmp short l_dispatchmsg_9
      
    l_dispatchmsg_8:
    add esp, 4 * 4
    
  l_dispatchmsg_9:
  pop edi
  pop ecx
  pop edx
  pop esi

  // finalize
  push eax
    cmp ecx, WM_WINDOWPOSCHANGED
    jnz l_dispatchmsg_92
      mov ebx, esi
      call gfree
      jmp short l_dispatchmsg_99
      
    l_dispatchmsg_92:
    cmp ecx, WM_PAINT
    jnz l_dispatchmsg_93
      call wmpaint
      jmp short l_dispatchmsg_99
      
    l_dispatchmsg_93:
    cmp ecx, WM_SHOWWINDOW
    jnz l_dispatchmsg_94
      call wmshow
      jmp short l_dispatchmsg_99
      
    l_dispatchmsg_94:
    
    //...
    
    l_dispatchmsg_99:
  pop eax
mov esp, ebp
pop ebp
ret 4

xgetmsg:
push ebp
mov ebp, esp

  l_xgetmsg_5:
  mov ah, 5 // get system message
  int 20h
  or al, al
  jz l_xgetmsg_8
    mov ah, 7 // get message
    int 20h
    or al, al
    jz l_xgetmsg_8
      mov ah, 45 // get pid, tid; OUT: edi = tid
      int 20h
      or edi, 16384
      mov ah, 35 // stop thread
      int 20h
      jmp short l_xgetmsg_5
    
  l_xgetmsg_8:
  mov eax, [ebp + 8] // MessageRec
  mov [eax + offset MessageRec.hwnd], edi
  mov [eax + offset MessageRec.message], ecx
  mov [eax + offset MessageRec.wParam], edx
  mov [eax + offset MessageRec.lParam], esi
  
  cmp ecx, WM_QUIT
  jnz l_xgetmsg_9
    xor eax, eax
    jmp short l_xgetmsg_99
    
  l_xgetmsg_9:
  mov eax, 1
  
  l_xgetmsg_99:
mov esp, ebp
pop ebp
ret 10h

postquit:
xor edi, edi
mov ecx, WM_QUIT
mov edx, [esp + 4]
xor esi, esi
call postmsg
ret 4

register:
push ebp
  mov ebp, esp
  mov esi, [ss:ebp + 8]
  
  mov ecx, [esi + offset WndClassRec.cbClsExtra]
  add ecx, sizeof WndClassRec
  push esi
    call malloc
  pop esi
  mov edi, ebx
  test edi, edi
  jz l_register_9
    mov ebx, regclass
    mov [edi + offset WndClassRec.next], ebx
    mov regclass, edi
    
    push esi
      mov ecx, sizeof WndClassRec
      mov [edi + offset WndClassRec.cbSize], ecx
      add esi, 4 // cbSize
      add edi, 4 // cbSize
      sub ecx, 4 + 4 // cbSize, next
      shr ecx, 2
      cld
      rep movsd
    pop esi
    
    xor eax, eax
    add edi, 4 // next
    mov ecx, [esi + offset WndClassRec.cbClsExtra]
    rep stosb
    
    //mov al, 0
    
  l_register_9:
  mov esp, ebp
pop ebp
ret 4

translmsg:
ret 4

[fill 0x1000]

export:
dd 0 /*export flags*/, 0/*dtm stamp*/
dw 0, 0 /*major, minor version*/
dd offset dll_name + CRVA/*name RVA*/
dd 1  /*ordinal base*/
dd 26 /* !!! number of address table entries*/
dd 26 /* !!! number of name pointers*/
dd offset export_table + CRVA/*export address table RVA*/
dd offset name_pointers + CRVA/*name pointers RVA*/
dd offset ordinal_table + CRVA/*ordinal table RVA*/

export_table:
dd offset beginpaint + CRVA
dd offset createwin + CRVA
dd offset defwinproc + CRVA
dd offset destroywin + CRVA
dd offset dispatchmsg + CRVA
dd offset drawicon + CRVA
dd offset drawiconex + CRVA
dd offset endpaint + CRVA
dd offset getclientrect + CRVA
dd offset getdc + CRVA
dd offset xgetmsg + CRVA
dd offset getupdaterect + CRVA
dd offset getwindowdc + CRVA
dd offset invalidaterect + CRVA
dd offset loadbitmap + CRVA
dd offset loadcursor + CRVA
dd offset loadicon + CRVA
dd offset loadimage + CRVA
dd offset postquit + CRVA
dd offset redrawwindow + CRVA
dd offset register + CRVA
dd offset releasedc + CRVA
dd offset setwinpos + CRVA
dd offset showwindow + CRVA
dd offset translmsg + CRVA
dd offset updatewindow + CRVA

name_pointers:
dd offset np_beginpaint + CRVA
dd offset np_createwin + CRVA
dd offset np_defwinproc + CRVA
dd offset np_destroywin + CRVA
dd offset np_dispatchmsg + CRVA
dd offset np_drawicon + CRVA
dd offset np_drawiconex + CRVA
dd offset np_endpaint + CRVA
dd offset np_getclientrect + CRVA
dd offset np_getdc + CRVA
dd offset np_getmsg + CRVA
dd offset np_getupdaterect + CRVA
dd offset np_getwindowdc + CRVA
dd offset np_invalidaterect + CRVA
dd offset np_loadbitmap + CRVA
dd offset np_loadcursor + CRVA
dd offset np_loadicon + CRVA
dd offset np_loadimage + CRVA
dd offset np_postquit + CRVA
dd offset np_redrawwindow + CRVA
dd offset np_register + CRVA
dd offset np_releasedc + CRVA
dd offset np_setwinpos + CRVA
dd offset np_showwindow + CRVA
dd offset np_translmsg + CRVA
dd offset np_updatewindow + CRVA

ordinal_table:
dw 0
dw 1
dw 2
dw 3
dw 4
dw 5
dw 6
dw 7
dw 8
dw 9
dw 10
dw 11
dw 12
dw 13
dw 14
dw 15
dw 16
dw 17
dw 18
dw 19
dw 20
dw 21
dw 22
dw 23
dw 24
dw 25

dll_name: db "user32.dll\0"

// Must be sorted !!!
np_beginpaint: db "BeginPaint\0"
np_createwin: db "CreateWindowExA\0"
np_defwinproc: db "DefWindowProcA\0"
np_destroywin: db "DestroyWindow\0"
np_dispatchmsg: db "DispatchMessageA\0"
np_drawicon: db "DrawIcon\0"
np_drawiconex: db "DrawIconEx\0"
np_endpaint: db "EndPaint\0"
np_getclientrect: db "GetClientRect\0"
np_getdc: db "GetDC\0"
np_getmsg: db "GetMessageA\0"
np_getupdaterect: db "GetUpdateRect\0"
np_getwindowdc: db "GetWindowDC\0"
np_invalidaterect: db "InvalidateRect\0"
np_loadbitmap: db "LoadBitmapA\0"
np_loadcursor: db "LoadCursorA\0"
np_loadicon: db "LoadIconA\0"
np_loadimage: db "LoadImageA\0"
np_postquit: db "PostQuitMessage\0"
np_redrawwindow: db "RedrawWindow\0"
np_register: db "RegisterClassExA\0"
np_releasedc: db "ReleaseDC\0"
np_setwinpos: db "SetWindowPos\0"
np_showwindow: db "ShowWindow\0"
np_translmsg: db "TranslateMessage\0"
np_updatewindow: db "UpdateWindow\0"

export_lastoffset:

lastoffset:

